# Random123.jl
*Julia implementation of [Random123](https://www.deshawresearch.com/resources_random123.html)*

Build Status:
[![Build Status](https://github.com/JuliaRandom/Random123.jl/workflows/CI%20Build/badge.svg?branch=master)](https://github.com/JuliaRandom/Random123.jl/actions)

Code Coverage:
[![codecov.io](https://codecov.io/github/JuliaRandom/Random123.jl/coverage.svg?branch=master)](https://codecov.io/github/JuliaRandom/Random123.jl?branch=master)

See [RandomNumbers.jl](https://github.com/JuliaRandom/RandomNumbers.jl) for details. The documentation is also
hosted [there](http://juliarandom.github.io/RandomNumbers.jl/stable/man/random123/).

# Installation

This package is registered. The stable version of this package requires Julia `1.8`. You can install it by:
```julia
(v1.5) pkg> add Random123
```
And then you can run the tests:
```julia
(v1.5) pkg> test Random123
```

This package is under [MIT License](./LICENSE.md). The original license of Random123 can be found
[here](./ORIGINAL_LICENSE).

import Base: copy, copyto!, ==
import Random: rand, seed!
import RandomNumbers: gen_seed, split_uint, union_uint, seed_type, unsafe_copyto!, unsafe_compare

"""
```julia
ARS1x{R} <: AbstractAESNI1x
ARS1x([seed, R=7])
```

ARS1x is one kind of ARS Counter-Based RNGs. It generates one `UInt128` number at a time.

`seed` is an `Integer` which will be automatically converted to `UInt128`.

`R` denotes to the Rounds which should be at least 1 and no more than 10. With 7 rounds (by default), it has
a considerable safety margin over the minimum number of rounds with no known statistical flaws, but still has
excellent performance.

Only available when [`R123_USE_AESNI`](@ref).
"""
mutable struct ARS1x{R} <: AbstractAESNI1x
    x::uint64x2
    ctr::uint64x2
    key::uint64x2
end

function ARS1x(seed::Integer=gen_seed(UInt128), R::Integer = 7)
    R = Int(R)
    @assert 1 ≤ R ≤ 10
    m0 = zero(uint64x2)
    r = ARS1x{R}(m0, m0, m0)
    seed!(r, seed)
end

function seed!(r::ARS1x, seed::Integer=gen_seed(UInt128))
    r.x = zero(uint64x2)
    r.ctr = zero(uint64x2)
    r.key = seed % UInt128
    random123_r(r)
    r
end

@inline seed_type(::Type{ARS1x{R}}) where R = UInt128

copyto!(dest::ARS1x{R}, src::ARS1x{R}) where R = unsafe_copyto!(dest, src, UInt128, 3)

copy(src::ARS1x{R}) where R = ARS1x{R}(src.x, src.ctr, src.key)

==(r1::ARS1x{R}, r2::ARS1x{R}) where R = unsafe_compare(r1, r2, UInt128, 3)

"""
```julia
ARS4x{R} <: AbstractAESNI4x
ARS4x([seed, R=7])
```

ARS4x is one kind of ARS Counter-Based RNGs. It generates four `UInt32` numbers at a time.

`seed` is a `Tuple` of four `Integer`s which will all be automatically converted to `UInt32`.

`R` denotes to the Rounds which must be at least 1 and no more than 10. With 7 rounds (by default), it has a
considerable safety margin over the minimum number of rounds with no known statistical flaws, but still has
excellent performance.

Only available when [`R123_USE_AESNI`](@ref).
"""
mutable struct ARS4x{R} <: AbstractAESNI4x
    x::uint64x2
    ctr1::uint64x2
    key::uint64x2
    p::Int
end

function ARS4x(seed::NTuple{4, Integer}=gen_seed(UInt32, 4), R::Integer=7)
    R = Int(R)
    @assert 1 ≤ R ≤ 10
    r = ARS4x{R}(zero(uint64x2), zero(uint64x2), zero(uint64x2), 0)
    seed!(r, seed)
end

function seed!(r::ARS4x, seed::NTuple{4, Integer}=gen_seed(UInt32, 4))
    r.ctr1 = zero(uint64x2)
    r.key = union_uint(Tuple(x % UInt32 for x in seed))
    r.p = 0
    random123_r(r)
    r
end

@inline seed_type(::Type{ARS4x{R}}) where R = NTuple{4, UInt32}

function copyto!(dest::ARS4x{R}, src::ARS4x{R}) where R
    unsafe_copyto!(dest, src, UInt128, 3)
    dest.p = src.p
    dest
end

copy(src::ARS4x{R}) where R = ARS4x{R}(src.x, src.ctr1, src.key, src.p)

==(r1::ARS4x{R}, r2::ARS4x{R}) where R = unsafe_compare(r1, r2, UInt128, 3) && r1.p ≡ r2.p

function expr_ars1xm128i(expr_key, expr_ctr, R)
    @assert R isa Int && 1 ≤ R ≤ 10
    rounds = [quote
        kk += kweyl
        v = _aes_enc(v, kk)
    end for _ in 2:R]
    quote
        ctr = $(expr_ctr)
        key = $(expr_key)
        kweyl = uint64x2(0xbb67ae8584caa73b, 0x9e3779b97f4a7c15)
        kk = key
        v = ctr ⊻ kk
        q1 = UInt128(ctr)
        q2 = UInt128(key)
        $(rounds...)
        kk += kweyl
        ret = _aes_enc_last(v, kk)
    end
end

@generated function ars1xm128i(r::Union{ARS1x{R}, ARS4x{R}}) where R
    expr_ctr = if r <: ARS1x
        :(r.ctr)
    elseif r <: ARS4x
        :(r.ctr1)
    else
        :(error("Unreachable"))
    end
    expr_key = :(r.key)
    expr_ars1xm128i(expr_key, expr_ctr, R)
end

@generated function ars(key::Tuple{uint64x2}, ctr::Tuple{uint64x2}, ::Val{R})::Tuple{uint64x2} where {R}
    :(($(expr_ars1xm128i(:(only(key)), :(only(ctr)), R)),))
end

"""
    ars(key::Tuple{UInt128}, ctr::Tuple{UInt128}, rounds::Val{R})::Tuple{UInt128} where {R}

Functional variant of [`ARS1x`](@ref) and [`ARS4x`](@ref). 
This function if free of mutability and side effects.
"""
function ars(key::Tuple{UInt128}, ctr::Tuple{UInt128}, rounds::Val{R})::Tuple{UInt128} where {R}
    k = map(uint64x2, key)
    c = map(uint64x2, ctr)
    map(UInt128,ars(k,c,rounds))
end

get_key(r::Union{ARS1x, ARS4x}) = (UInt128(r.key),)
get_ctr(r::ARS1x) = (UInt128(r.ctr),)
get_ctr(r::ARS4x) = (UInt128(r.ctr1),)

@inline function random123_r(r::ARS1x{R}) where R
    r.x = ars1xm128i(r)
    (UInt128(r.x),)
end

@inline function random123_r(r::ARS4x{R}) where R
    r.x = ars1xm128i(r)
    split_uint(UInt128(r.x), UInt32)
end

using Base: llvmcall
import Base.(+)

using ..Random123: R123Generator1x, R123Generator4x
import ..Random123: random123_r, set_counter!

const LLVM_ARCH_STRING::String = @static if R123_USE_ARM_AARCH64_FEAT_AES
    "aarch64"
elseif R123_USE_ARM_AARCH32_FEAT_AES
    "arm"
else
    @error "Impossible situation!  Something has gone seriously wrong."
end

const LITTLE_ENDIAN::Bool = ENDIAN_BOM ≡ 0x04030201

abstract type ArmVec128 end
@inline Base.convert(::Type{T}, x::ArmVec128) where {T<:Union{ArmVec128, UInt128}} =
    unsafe_load(Ptr{T}(pointer_from_objref(Ref(x))))
@inline Base.convert(::Type{T}, x::UInt128) where {T<:ArmVec128} =
    unsafe_load(Ptr{T}(pointer_from_objref(Ref(x))))
@inline Base.UInt128(x::ArmVec128) = convert(UInt128, x)
@inline (::Type{T})(x::Union{ArmVec128, UInt128}) where {T<:ArmVec128} = convert(T, x)
@inline Base.convert(::Type{T}, x::Union{Signed, Unsigned}) where {T<:ArmVec128} =
    convert(T, UInt128(x))
@inline Base.convert(::Type{T}, x::ArmVec128) where T <: Union{Signed, Unsigned} =
    convert(T, UInt128(x))

const VEC_FLAVORS = [(2^(7 - i) => 2^i) for i in 3:6]
for (num_elems, elem_bits) in VEC_FLAVORS
    vec_symb = Symbol("uint$(elem_bits)x$(num_elems)")
    lvec_symb = Symbol("uint$(elem_bits)x$(num_elems)_lvec")
    elem_ty_symb = Symbol("UInt$elem_bits")
    llvm_xor =
        """%3 = xor <$(num_elems) x i$(elem_bits)> %1, %0
        ret <$(num_elems) x i$(elem_bits)> %3"""
    @eval begin
        const $lvec_symb = NTuple{$num_elems, VecElement{$elem_ty_symb}}
        struct $vec_symb <: ArmVec128
            data::$lvec_symb
        end
        @inline $vec_symb(x::Union{UInt128, ArmVec128}) = convert($vec_symb, x)

        @inline function $vec_symb(bytes::Vararg{$elem_ty_symb, $num_elems})
            bytes_prepped = bytes
            @static if $LITTLE_ENDIAN
                bytes_prepped = reverse(bytes_prepped)
            end
            bytes_vec::$lvec_symb = VecElement.(bytes_prepped)
            return $vec_symb(bytes_vec)
        end

        @inline Base.zero(::Type{$vec_symb}) = convert($vec_symb, zero(UInt128))
        @inline Base.xor(a::$vec_symb, b::$vec_symb) = llvmcall(
            $llvm_xor,
            $lvec_symb, Tuple{$lvec_symb, $lvec_symb},
            a.data, b.data,
        ) |> $vec_symb
    end
end

@inline Base.one(::Type{uint64x2}) = uint64x2(zero(UInt64), one(UInt64))
@inline (+)(a::uint64x2, b::uint64x2) = llvmcall(
    """%3 = add <2 x i64> %1, %0
    ret <2 x i64> %3""",
    uint64x2_lvec, Tuple{uint64x2_lvec, uint64x2_lvec},
    a.data, b.data,
) |> uint64x2
@inline (+)(a::uint64x2, b::Integer) = a + uint64x2(UInt128(b))

# Raw NEON instrinsics, provided by FEAT_AES
const ARM_AESE_LLVM_INTRINSIC = "llvm.$LLVM_ARCH_STRING.crypto.aese"
@inline _vaese(a::uint8x16, b::uint8x16) = ccall(
    ARM_AESE_LLVM_INTRINSIC,
    llvmcall,
    uint8x16_lvec,
    (uint8x16_lvec, uint8x16_lvec),
    a.data, b.data,
) |> uint8x16
const ARM_AESMC_LLVM_INTRINSIC = "llvm.$LLVM_ARCH_STRING.crypto.aesmc"
@inline _vaesmc(a::uint8x16) = ccall(
    ARM_AESMC_LLVM_INTRINSIC,
    llvmcall,
    uint8x16_lvec,
    (uint8x16_lvec,),
    a.data,
) |> uint8x16

"""
Assistant function for AES keygen. Originally compiled for AArch64 from the C source code:
```cpp
uint8x16_t _mm_aeskeygenassist_helper(uint8x16_t a)
{
    uint8x16_t dest = {
        // Undo ShiftRows step from AESE and extract X1 and X3
        a[0x4], a[0x1], a[0xE], a[0xB],  // SubBytes(X1)
        a[0x1], a[0xE], a[0xB], a[0x4],  // ROT(SubBytes(X1))
        a[0xC], a[0x9], a[0x6], a[0x3],  // SubBytes(X3)
        a[0x9], a[0x6], a[0x3], a[0xC],  // ROT(SubBytes(X3))
    };
    return dest;
}
```
Then made architecture-agnostic as LLVM IR.
"""
@inline _aes_key_gen_shuffle_helper(a::uint8x16) = llvmcall(
    """%2 = shufflevector <16 x i8> %0, <16 x i8> undef, <16 x i32> <i32 4, i32 1, i32 14, i32 11, i32 1, i32 14, i32 11, i32 4, i32 12, i32 9, i32 6, i32 3, i32 9, i32 6, i32 3, i32 12>
    ret <16 x i8> %2""",
    uint8x16_lvec, Tuple{uint8x16_lvec},
    a.data,
) |> uint8x16

# Mimics of the x86 AES-NI instrinsics
#
# Algorithm translations courtesy of the SIMD Everywhere and SSE2NEON projects:
# https://github.com/simd-everywhere/simde/blob/v0.8.0-rc1/simde/x86/aes.h
# https://github.com/DLTcollab/sse2neon/blob/v1.6.0/sse2neon.h
@inline function _aes_enc(a::uint64x2, round_key::uint64x2)
    res = _vaesmc(_vaese(uint8x16(a), zero(uint8x16)))
    return uint64x2(res) ⊻ round_key
end
@inline function _aes_enc_last(a::uint64x2, round_key::uint64x2)
    res = _vaese(uint8x16(a), zero(uint8x16))
    return uint64x2(res) ⊻ round_key
end
@inline function _aes_key_gen_assist(a::uint64x2, ::Val{R}) where {R}
    res = _aes_key_gen_shuffle_helper(_vaese(uint8x16(a), zero(uint8x16)))
    r = R % UInt32
    z = zero(UInt32)
    return uint64x2(res) ⊻ uint64x2(uint32x4(r, z, r, z))
end

"""
    _aes_enc_full(a::uint64x2, round_keys::NTuple{N,uint64x2})::uint64x2 where {N}

Full AES encryption flow for N rounds.
"""
@inline function _aes_enc_full(a::uint64x2, round_keys::NTuple{N,uint64x2})::uint64x2 where {N}
    res = uint8x16(a)
    for (i, key) in enumerate(round_keys)
        if i ≢ N
            res = _vaese(res, uint8x16(key))
            if i ≢ N - 1
                res = _vaesmc(res)
            end
        else
            return uint64x2(res ⊻ uint8x16(key))
        end
    end
    return a # pathological 0-round case
end

"Abstract RNG that generates one number at a time and is based on AESNI."
abstract type AbstractAESNI1x <: R123Generator1x{UInt128} end
"Abstract RNG that generates four numbers at a time and is based on AESNI."
abstract type AbstractAESNI4x <: R123Generator4x{UInt32} end

@inline function set_counter!(
    r::AbstractAESNI4x,
    ctr::NTuple{4, Integer}
)
    r.p = 0
    r.ctr1 = union_uint(Tuple(x % UInt32 for x in ctr))
    random123_r(r)
    r
end

@inline inc_counter!(r::AbstractAESNI4x) = (r.ctr1 += one(uint64x2); r)

import Base: copy, copyto!, ==, llvmcall
import Random: rand, seed!
import RandomNumbers: gen_seed, union_uint, seed_type, unsafe_copyto!, unsafe_compare


"The key for AESNI."
mutable struct AESNIKey
    key1::uint64x2
    key2::uint64x2
    key3::uint64x2
    key4::uint64x2
    key5::uint64x2
    key6::uint64x2
    key7::uint64x2
    key8::uint64x2
    key9::uint64x2
    key10::uint64x2
    key11::uint64x2
    AESNIKey() = new(0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)
end

copyto!(dest::AESNIKey, src::AESNIKey) = unsafe_copyto!(dest, src, UInt128, 11)

copy(src::AESNIKey) = copyto!(AESNIKey(), src)

==(key1::AESNIKey, key2::AESNIKey) = unsafe_compare(key1, key2, UInt128, 11)

"""
Assistant function for AES128. Originally compiled for x86 from the C++ source code:
```cpp
R123_STATIC_INLINE __m128i AES_128_ASSIST (__m128i temp1, __m128i temp2) {
    __m128i temp3;
    temp2 = _mm_shuffle_epi32 (temp2 ,0xff);
    temp3 = _mm_slli_si128 (temp1, 0x4);
    temp1 = _mm_xor_si128 (temp1, temp3);
    temp3 = _mm_slli_si128 (temp3, 0x4);
    temp1 = _mm_xor_si128 (temp1, temp3);
    temp3 = _mm_slli_si128 (temp3, 0x4);
    temp1 = _mm_xor_si128 (temp1, temp3);
    temp1 = _mm_xor_si128 (temp1, temp2);
    return temp1;
}
```
Then made architecture-agnostic as LLVM IR.
"""
_aes_128_assist(a::uint64x2, b::uint64x2) = llvmcall(
    """%3 = bitcast <2 x i64> %1 to <4 x i32>
    %4 = shufflevector <4 x i32> %3, <4 x i32> undef, <4 x i32> <i32 3, i32 3, i32 3, i32 3>
    %5 = bitcast <4 x i32> %4 to <2 x i64>
    %6 = bitcast <2 x i64> %0 to <16 x i8>
    %7 = shufflevector <16 x i8> <i8 undef, i8 undef, i8 undef, i8 undef, i8 undef, i8 undef, i8 undef, i8 undef, i8 undef, i8 undef, i8 undef, i8 undef, i8 0, i8 0, i8 0, i8 0>, <16 x i8> %6, <16 x i32> <i32 12, i32 13, i32 14, i32 15, i32 16, i32 17, i32 18, i32 19, i32 20, i32 21, i32 22, i32 23, i32 24, i32 25, i32 26, i32 27>
    %8 = bitcast <16 x i8> %7 to <2 x i64>
    %9 = xor <2 x i64> %8, %0
    %10 = shufflevector <16 x i8> <i8 undef, i8 undef, i8 undef, i8 undef, i8 undef, i8 undef, i8 undef, i8 undef, i8 undef, i8 undef, i8 undef, i8 undef, i8 0, i8 0, i8 0, i8 0>, <16 x i8> %7, <16 x i32> <i32 12, i32 13, i32 14, i32 15, i32 16, i32 17, i32 18, i32 19, i32 20, i32 21, i32 22, i32 23, i32 24, i32 25, i32 26, i32 27>
    %11 = bitcast <16 x i8> %10 to <2 x i64>
    %12 = xor <2 x i64> %9, %11
    %13 = shufflevector <16 x i8> <i8 undef, i8 undef, i8 undef, i8 undef, i8 undef, i8 undef, i8 undef, i8 undef, i8 undef, i8 undef, i8 undef, i8 undef, i8 0, i8 0, i8 0, i8 0>, <16 x i8> %10, <16 x i32> <i32 12, i32 13, i32 14, i32 15, i32 16, i32 17, i32 18, i32 19, i32 20, i32 21, i32 22, i32 23, i32 24, i32 25, i32 26, i32 27>
    %14 = bitcast <16 x i8> %13 to <2 x i64>
    %15 = xor <2 x i64> %12, %5
    %16 = xor <2 x i64> %15, %14
    ret <2 x i64> %16""",
    uint64x2_lvec, Tuple{uint64x2_lvec, uint64x2_lvec},
    a.data, b.data
) |> uint64x2

function _aesni_expand!(k::AESNIKey, rkey::uint64x2)
    k.key1 = rkey
    tmp = _aes_key_gen_assist(rkey, Val(0x1))
    rkey = _aes_128_assist(rkey, tmp)
    k.key2 = rkey

    tmp = _aes_key_gen_assist(rkey, Val(0x2))
    rkey = _aes_128_assist(rkey, tmp)
    k.key3 = rkey

    tmp = _aes_key_gen_assist(rkey, Val(0x4))
    rkey = _aes_128_assist(rkey, tmp)
    k.key4 = rkey

    tmp = _aes_key_gen_assist(rkey, Val(0x8))
    rkey = _aes_128_assist(rkey, tmp)
    k.key5 = rkey

    tmp = _aes_key_gen_assist(rkey, Val(0x10))
    rkey = _aes_128_assist(rkey, tmp)
    k.key6 = rkey

    tmp = _aes_key_gen_assist(rkey, Val(0x20))
    rkey = _aes_128_assist(rkey, tmp)
    k.key7 = rkey

    tmp = _aes_key_gen_assist(rkey, Val(0x40))
    rkey = _aes_128_assist(rkey, tmp)
    k.key8 = rkey

    tmp = _aes_key_gen_assist(rkey, Val(0x80))
    rkey = _aes_128_assist(rkey, tmp)
    k.key9 = rkey

    tmp = _aes_key_gen_assist(rkey, Val(0x1b))
    rkey = _aes_128_assist(rkey, tmp)
    k.key10 = rkey

    tmp = _aes_key_gen_assist(rkey, Val(0x36))
    rkey = _aes_128_assist(rkey, tmp)
    k.key11 = rkey

    k
end

AESNIKey(key::UInt128) = _aesni_expand!(AESNIKey(), uint64x2(key))

"""
```julia
AESNI1x <: AbstractAESNI1x
AESNI1x([seed])
```

AESNI1x is one kind of AESNI Counter-Based RNGs. It generates one `UInt128` number at a time.

`seed` is an `Integer` which will be automatically converted to `UInt128`.

Only available when [`R123_USE_AESNI`](@ref).
"""
mutable struct AESNI1x <: AbstractAESNI1x
    x::uint64x2
    ctr::uint64x2
    key::AESNIKey
end

function AESNI1x(seed::Integer=gen_seed(UInt128))
    r = AESNI1x(0, 0, AESNIKey())
    seed!(r, seed)
    r
end

function seed!(r::AESNI1x, seed::Integer=gen_seed(UInt128))
    r.x = zero(uint64x2)
    r.ctr = zero(uint64x2)
    _aesni_expand!(r.key, uint64x2(seed % UInt128))
    random123_r(r)
    r
end

seed_type(::Type{AESNI1x}) = UInt128

function copyto!(dest::AESNI1x, src::AESNI1x)
    dest.x = src.x
    dest.ctr = src.ctr
    copyto!(dest.key, src.key)
    dest
end

copy(src::AESNI1x) = copyto!(AESNI1x(), src)

==(r1::AESNI1x, r2::AESNI1x) = r1.x == r2.x && r1.key == r2.key && r1.ctr == r2.ctr

"""
```julia
AESNI4x <: AbstractAESNI4x
AESNI4x([seed])
```

AESNI4x is one kind of AESNI Counter-Based RNGs. It generates four `UInt32` numbers at a time.

`seed` is a `Tuple` of four `Integer`s which will all be automatically converted to `UInt32`.

Only available when [`R123_USE_AESNI`](@ref).
"""
mutable struct AESNI4x <: AbstractAESNI4x
    x::uint64x2
    ctr1::uint64x2
    key::AESNIKey
    p::Int
end

function AESNI4x(seed::NTuple{4, Integer}=gen_seed(UInt32, 4))
    r = AESNI4x(zero(uint64x2), zero(uint64x2), AESNIKey(), 0)
    seed!(r, seed)
    r
end

function seed!(r::AESNI4x, seed::NTuple{4, Integer}=gen_seed(UInt32, 4))
    key = union_uint(Tuple(x % UInt32 for x in seed))
    r.ctr1 = 0
    _aesni_expand!(r.key, uint64x2(key))
    r.p = 0
    random123_r(r)
    r
end

seed_type(::Type{AESNI4x}) = NTuple{4, UInt32}

function copyto!(dest::AESNI4x, src::AESNI4x)
    unsafe_copyto!(dest, src, UInt128, 2)
    copyto!(dest.key, src.key)
    dest.p = src.p
    dest
end

copy(src::AESNI4x) = copyto!(AESNI4x(), src)
==(r1::AESNI4x, r2::AESNI4x) = unsafe_compare(r1, r2, UInt128, 2) &&
    r1.key == r2.key && r1.p == r2.p

function get_key_uint64x2(o::Union{AESNI1x, AESNI4x})::NTuple{11, uint64x2}
    k = o.key
    (k.key1,k.key2,k.key3,k.key4,k.key5,k.key6,k.key7,k.key8,k.key9,k.key10,k.key11)
end
get_ctr_uint64x2(o::AESNI4x)::Tuple{uint64x2} = (o.ctr1,)
get_ctr_uint64x2(o::AESNI1x)::Tuple{uint64x2} = (o.ctr,)
get_key(o::Union{AESNI1x, AESNI4x})::NTuple{11,UInt128} = map(UInt128, get_key_uint64x2(o))
get_ctr(o::Union{AESNI1x, AESNI4x})::Tuple{UInt128} = map(UInt128, get_ctr_uint64x2(o))

@inline aesni(key::NTuple{11,uint64x2}, ctr::Tuple{uint64x2})::Tuple{uint64x2} =
    (_aes_enc_full(only(ctr), key),)

"""
    aesni(key::NTuple{11,UInt128}, ctr::Tuple{UInt128})::Tuple{UInt128}

Functional variant of [`AESNI1x`](@ref) and [`AESNI4x`](@ref).
This function if free of mutability and side effects.
"""
@inline function aesni(key::NTuple{11,UInt128}, ctr::Tuple{UInt128})::Tuple{UInt128}
    k = map(uint64x2, key)
    c = map(uint64x2, ctr)
    map(UInt128,aesni(k,c))
end


@inline function random123_r(r::AESNI1x)
    r.x = only(aesni(get_key_uint64x2(r), get_ctr_uint64x2(r)))
    (UInt128(r.x),)
end

@inline function random123_r(r::AESNI4x)
    r.x = only(aesni(get_key_uint64x2(r), get_ctr_uint64x2(r)))
    split_uint(UInt128(r.x), UInt32)
end

using Base: llvmcall
import Base.(+)

using ..Random123: R123Generator1x, R123Generator4x
import ..Random123: random123_r, set_counter!

const LITTLE_ENDIAN::Bool = ENDIAN_BOM ≡ 0x04030201

const uint64x2_lvec = NTuple{2, VecElement{UInt64}}
struct uint64x2
    data::uint64x2_lvec
end
@inline Base.convert(::Type{uint64x2}, x::UInt128) = unsafe_load(Ptr{uint64x2}(pointer_from_objref(Ref(x))))
@inline Base.convert(::Type{UInt128}, x::uint64x2) = unsafe_load(Ptr{UInt128}(pointer_from_objref(Ref(x))))
@inline UInt128(x::uint64x2) = convert(UInt128, x)
@inline uint64x2(x::UInt128) = convert(uint64x2, x)
@inline Base.convert(::Type{uint64x2}, x::Union{Signed, Unsigned}) = convert(uint64x2, UInt128(x))
@inline Base.convert(::Type{T}, x::uint64x2) where T <: Union{Signed, Unsigned} = convert(T, UInt128(x))

@inline uint64x2(hi::UInt64, lo::UInt64) = @static if LITTLE_ENDIAN
    uint64x2((VecElement(lo), VecElement(hi)))
else
    uint64x2((VecElement(hi), VecElement(lo)))
end

@inline Base.zero(::Type{uint64x2}) = convert(uint64x2, zero(UInt128))
@inline Base.one(::Type{uint64x2}) = uint64x2(zero(UInt64), one(UInt64))
@inline Base.xor(a::uint64x2, b::uint64x2) = llvmcall(
    """%3 = xor <2 x i64> %1, %0
    ret <2 x i64> %3""",
    uint64x2_lvec, Tuple{uint64x2_lvec, uint64x2_lvec},
    a.data, b.data,
) |> uint64x2
@inline (+)(a::uint64x2, b::uint64x2) = llvmcall(
    """%3 = add <2 x i64> %1, %0
    ret <2 x i64> %3""",
    uint64x2_lvec, Tuple{uint64x2_lvec, uint64x2_lvec},
    a.data, b.data,
) |> uint64x2
@inline (+)(a::uint64x2, b::Integer) = a + uint64x2(UInt128(b))

const uint8x16_lvec = NTuple{16, VecElement{UInt8}}
struct uint8x16
    data::uint8x16_lvec
end
@inline Base.convert(::Type{uint64x2}, x::uint8x16) = unsafe_load(Ptr{uint64x2}(pointer_from_objref(Ref(x))))
@inline Base.convert(::Type{uint8x16}, x::uint64x2) = unsafe_load(Ptr{uint8x16}(pointer_from_objref(Ref(x))))
@inline uint8x16(x::uint64x2) = convert(uint8x16, x)
@inline uint64x2(x::uint8x16) = convert(uint64x2, x)
@inline Base.convert(::Type{uint8x16}, x::UInt128) = unsafe_load(Ptr{uint8x16}(pointer_from_objref(Ref(x))))
@inline Base.convert(::Type{UInt128}, x::uint8x16) = unsafe_load(Ptr{UInt128}(pointer_from_objref(Ref(x))))
@inline UInt128(x::uint8x16) = convert(UInt128, x)
@inline uint8x16(x::UInt128) = convert(uint8x16, x)
@inline Base.convert(::Type{uint8x16}, x::Union{Signed, Unsigned}) = convert(uint8x16, UInt128(x))
@inline Base.convert(::Type{T}, x::uint8x16) where T <: Union{Signed, Unsigned} = convert(T, UInt128(x))

@inline function uint8x16(bytes::Vararg{UInt8, 16})
    bytes_prepped = bytes
    @static if LITTLE_ENDIAN
        bytes_prepped = reverse(bytes_prepped)
    end
    bytes_vec::uint8x16_lvec = VecElement.(bytes_prepped)
    return uint8x16(bytes_vec)
end

@inline Base.zero(::Type{uint8x16}) = convert(uint8x16, zero(UInt128))
@inline Base.xor(a::uint8x16, b::uint8x16) = llvmcall(
    """%3 = xor <16 x i8> %1, %0
    ret <16 x i8> %3""",
    uint8x16_lvec, Tuple{uint8x16_lvec, uint8x16_lvec},
    a.data, b.data,
) |> uint8x16

const uint32x4_lvec = NTuple{4, VecElement{UInt32}}
struct uint32x4
    data::uint32x4_lvec
end
@inline Base.convert(::Type{uint64x2}, x::uint32x4) = unsafe_load(Ptr{uint64x2}(pointer_from_objref(Ref(x))))
@inline Base.convert(::Type{uint32x4}, x::uint64x2) = unsafe_load(Ptr{uint32x4}(pointer_from_objref(Ref(x))))
@inline uint32x4(x::uint64x2) = convert(uint32x4, x)
@inline uint64x2(x::uint32x4) = convert(uint64x2, x)
@inline Base.convert(::Type{uint8x16}, x::uint32x4) = unsafe_load(Ptr{uint8x16}(pointer_from_objref(Ref(x))))
@inline Base.convert(::Type{uint32x4}, x::uint8x16) = unsafe_load(Ptr{uint32x4}(pointer_from_objref(Ref(x))))
@inline uint32x4(x::uint8x16) = convert(uint32x4, x)
@inline uint8x16(x::uint32x4) = convert(uint8x16, x)
@inline Base.convert(::Type{uint32x4}, x::UInt128) = unsafe_load(Ptr{uint32x4}(pointer_from_objref(Ref(x))))
@inline Base.convert(::Type{UInt128}, x::uint32x4) = unsafe_load(Ptr{UInt128}(pointer_from_objref(Ref(x))))
@inline UInt128(x::uint32x4) = convert(UInt128, x)
@inline uint32x4(x::UInt128) = convert(uint32x4, x)
@inline Base.convert(::Type{uint32x4}, x::Union{Signed, Unsigned}) = convert(uint32x4, UInt128(x))
@inline Base.convert(::Type{T}, x::uint32x4) where T <: Union{Signed, Unsigned} = convert(T, UInt128(x))

@inline function uint32x4(bytes::Vararg{UInt32, 4})
    bytes_prepped = bytes
    @static if LITTLE_ENDIAN
        bytes_prepped = reverse(bytes_prepped)
    end
    bytes_vec::uint32x4_lvec = VecElement.(bytes_prepped)
    return uint32x4(bytes_vec)
end

@inline Base.zero(::Type{uint32x4}) = convert(uint32x4, zero(UInt128))
@inline Base.xor(a::uint32x4, b::uint32x4) = llvmcall(
    """%3 = xor <4 x i32> %1, %0
    ret <4 x i32> %3""",
    uint32x4_lvec, Tuple{uint32x4_lvec, uint32x4_lvec},
    a.data, b.data,
) |> uint32x4

# Raw NEON instrinsics, provided by FEAT_AES
@inline _vaese(a::uint8x16, b::uint8x16) = ccall(
    "llvm.aarch64.crypto.aese",
    llvmcall,
    uint8x16_lvec,
    (uint8x16_lvec, uint8x16_lvec),
    a.data, b.data,
) |> uint8x16
@inline _vaesmc(a::uint8x16) = ccall(
    "llvm.aarch64.crypto.aesmc",
    llvmcall,
    uint8x16_lvec,
    (uint8x16_lvec,),
    a.data,
) |> uint8x16

"""
Assistant function for AES keygen. Originally compiled for AArch64 from the C source code:
```cpp
uint8x16_t _mm_aeskeygenassist_helper(uint8x16_t a)
{
    uint8x16_t dest = {
        // Undo ShiftRows step from AESE and extract X1 and X3
        a[0x4], a[0x1], a[0xE], a[0xB],  // SubBytes(X1)
        a[0x1], a[0xE], a[0xB], a[0x4],  // ROT(SubBytes(X1))
        a[0xC], a[0x9], a[0x6], a[0x3],  // SubBytes(X3)
        a[0x9], a[0x6], a[0x3], a[0xC],  // ROT(SubBytes(X3))
    };
    return dest;
}
```
Then made architecture-agnostic as LLVM IR.
"""
@inline _aes_key_gen_shuffle_helper(a::uint8x16) = llvmcall(
    """%2 = shufflevector <16 x i8> %0, <16 x i8> undef, <16 x i32> <i32 4, i32 1, i32 14, i32 11, i32 1, i32 14, i32 11, i32 4, i32 12, i32 9, i32 6, i32 3, i32 9, i32 6, i32 3, i32 12>
    ret <16 x i8> %2""",
    uint8x16_lvec, Tuple{uint8x16_lvec},
    a.data,
) |> uint8x16

# Mimics of the x86 AES-NI instrinsics
#
# Algorithm translations courtesy of the SIMD Everywhere and SSE2NEON projects:
# https://github.com/simd-everywhere/simde/blob/v0.8.0-rc1/simde/x86/aes.h
# https://github.com/DLTcollab/sse2neon/blob/v1.6.0/sse2neon.h
@inline function _aes_enc(a::uint64x2, round_key::uint64x2)
    res = _vaesmc(_vaese(uint8x16(a), zero(uint8x16)))
    return uint64x2(res) ⊻ round_key
end
@inline function _aes_enc_last(a::uint64x2, round_key::uint64x2)
    res = _vaese(uint8x16(a), zero(uint8x16))
    return uint64x2(res) ⊻ round_key
end
@inline function _aes_key_gen_assist(a::uint64x2, ::Val{R}) where {R}
    res = _aes_key_gen_shuffle_helper(_vaese(uint8x16(a), zero(uint8x16)))
    r = R % UInt32
    z = zero(UInt32)
    return uint64x2(res) ⊻ uint64x2(uint32x4(r, z, r, z))
end

"""
    _aes_enc_full(a::uint64x2, round_keys::NTuple{N,uint64x2})::uint64x2 where {N}

Full AES encryption flow for N rounds.
"""
@inline function _aes_enc_full(a::uint64x2, round_keys::NTuple{N,uint64x2})::uint64x2 where {N}
    res = uint8x16(a)
    for (i, key) in enumerate(round_keys)
        if i ≢ N
            res = _vaese(res, uint8x16(key))
            if i ≢ N - 1
                res = _vaesmc(res)
            end
        else
            return uint64x2(res ⊻ uint8x16(key))
        end
    end
    return a # pathological 0-round case
end

"Abstract RNG that generates one number at a time and is based on AESNI."
abstract type AbstractAESNI1x <: R123Generator1x{UInt128} end
"Abstract RNG that generates four numbers at a time and is based on AESNI."
abstract type AbstractAESNI4x <: R123Generator4x{UInt32} end

@inline function set_counter!(
    r::AbstractAESNI4x,
    ctr::NTuple{4, Integer}
)
    r.p = 0
    r.ctr1 = union_uint(Tuple(x % UInt32 for x in ctr))
    random123_r(r)
    r
end

@inline inc_counter!(r::AbstractAESNI4x) = (r.ctr1 += one(uint64x2); r)

import Random: rand, seed!
import RandomNumbers: AbstractRNG

const R123Array1x{T<:Union{UInt128}}        = NTuple{1, T}
const R123Array2x{T<:Union{UInt32, UInt64}} = NTuple{2, T}
const R123Array4x{T<:Union{UInt32, UInt64}} = NTuple{4, T}

"The base abstract type for RNGs in [Random123 Family](@ref)."
abstract type AbstractR123{T<:Union{UInt32, UInt64, UInt128}} <: AbstractRNG{T} end

"RNG that generates one number at a time."
abstract type R123Generator1x{T} <: AbstractR123{T} end
"RNG that generates two numbers at a time."
abstract type R123Generator2x{T} <: AbstractR123{T} end
"RNG that generates four numbers at a time."
abstract type R123Generator4x{T} <: AbstractR123{T} end

_value(r::AbstractR123{T}, i = 1, ::Type{T2} = T) where {T, T2} = unsafe_load(Ptr{T2}(pointer_from_objref(r)), i)

"Set the counter of a Random123 RNG."
@inline function set_counter!(r::R123Generator1x{T}, ctr::Integer) where T <: UInt128
    r.ctr = ctr % T
    random123_r(r)
    r
end

@inline function set_counter!(
    r::R123Generator2x{T},
    (ctr1, ctr2)::NTuple{2, Integer}
) where T <: Union{UInt32, UInt64}
    r.p = 0
    r.ctr1 = ctr1 % T
    r.ctr2 = ctr2 % T
    random123_r(r)
    r
end

@inline function set_counter!(
    r::R123Generator4x{T},
    (ctr1, ctr2, ctr3, ctr4)::NTuple{4, Integer}
) where T <: Union{UInt32, UInt64}
    r.p = 0
    r.ctr1 = ctr1 % T
    r.ctr2 = ctr2 % T
    r.ctr3 = ctr3 % T
    r.ctr4 = ctr4 % T
    random123_r(r)
    r
end
@inline set_counter!(r::R123Generator2x, ctr::Integer) = set_counter!(r, (ctr, 0))
@inline set_counter!(r::R123Generator4x, ctr::Integer) = set_counter!(r, (ctr, 0, 0, 0))

@inline inc_counter!(r::R123Generator1x{T}) where T = (r.ctr += one(T); r)
@inline function inc_counter!(r::R123Generator2x{T}) where T
    r.ctr1 += one(T)
    r.ctr1 == zero(T) && (r.ctr2 += one(T))
    r
end
@inline function inc_counter!(r::R123Generator4x{T}) where T
    r.ctr1 += one(T)
    if r.ctr1 == zero(T)
        r.ctr2 += one(T)
        if r.ctr2 == zero(T)
            r.ctr3 += one(T)
            if r.ctr3 == zero(T)
                r.ctr4 += one(T)
            end
        end
    end
    r
end

@inline function rand(r::R123Generator1x{T}, ::Type{T}) where T <: UInt128
    r.ctr += one(T)
    random123_r(r)
    _value(r)
end

@inline function rand(r::R123Generator2x{T}, ::Type{T}) where T <: Union{UInt32, UInt64}
    to = one(T)
    if r.p == 1
        inc_counter!(r)
        random123_r(r)
        r.p = 0
        return r.x2
    end
    r.p = 1
    r.x1
end

@inline function rand(r::R123Generator4x{T}, ::Type{T}) where T <: Union{UInt32, UInt64}
    if r.p == 4
        inc_counter!(r)
        random123_r(r)
        r.p = 0
    end
    r.p += 1
    _value(r, r.p)
end

@inline function rand(r::R123Generator1x{T}, ::Type{R123Array1x{T}}) where T <: UInt128
    inc_counter!(r)
    random123_r(r)
end

@inline function rand(r::R123Generator2x{T}, ::Type{R123Array2x{T}}) where T <: Union{UInt32, UInt64}
    if r.p > 0
        inc_counter!(r)
    end
    ret = random123_r(r) # which returns a Tuple{T, T}
    r.p = 1
    ret
end

@inline function rand(r::R123Generator4x{T}, ::Type{R123Array4x{T}}) where T <: Union{UInt32, UInt64}
    if r.p > 0
        inc_counter!(r)
    end
    ret = random123_r(r)
    r.p = 4
    ret
end

for (T, DT) in ((UInt32, UInt64), (UInt64, UInt128))
    @eval @inline function rand(r::R123Generator2x{$T}, ::Type{$DT})
        if r.p == 1
            inc_counter!(r)
            random123_r(r)
        end
        r.p = 1
        _value(r, 1, $DT)
    end
end

@inline function rand(r::R123Generator4x{UInt32}, ::Type{UInt128})
    if r.p > 0
        inc_counter!(r)
        random123_r(r)
    end
    r.p = 4
    _value(r, 1, UInt128)
end

"Do one iteration and
return the result tuple of a Random123 RNG object."
random123_r

import Base: copy, copyto!, ==
import Random: seed!
import RandomNumbers: gen_seed, seed_type, unsafe_copyto!, unsafe_compare

@inline threefry_rotl(x::UInt64, N) = (x << (N & 63)) | (x >> ((64-N) & 63))
@inline threefry_rotl(x::UInt32, N) = (x << (N & 31)) | (x >> ((32-N) & 31))

@inline SKEIN_KS_PARITY(::Type{UInt32}) = 0x1BD11BDA
@inline SKEIN_KS_PARITY(::Type{UInt64}) = 0x1BD11BDAA9FC1A22

@inline Rx4_0_0(::Type{UInt64}) = 14
@inline Rx4_0_1(::Type{UInt64}) = 16
@inline Rx4_1_0(::Type{UInt64}) = 52
@inline Rx4_1_1(::Type{UInt64}) = 57
@inline Rx4_2_0(::Type{UInt64}) = 23
@inline Rx4_2_1(::Type{UInt64}) = 40
@inline Rx4_3_0(::Type{UInt64}) =  5
@inline Rx4_3_1(::Type{UInt64}) = 37
@inline Rx4_4_0(::Type{UInt64}) = 25
@inline Rx4_4_1(::Type{UInt64}) = 33
@inline Rx4_5_0(::Type{UInt64}) = 46
@inline Rx4_5_1(::Type{UInt64}) = 12
@inline Rx4_6_0(::Type{UInt64}) = 58
@inline Rx4_6_1(::Type{UInt64}) = 22
@inline Rx4_7_0(::Type{UInt64}) = 32
@inline Rx4_7_1(::Type{UInt64}) = 32

@inline Rx2_0_0(::Type{UInt64}) = 16
@inline Rx2_1_0(::Type{UInt64}) = 42
@inline Rx2_2_0(::Type{UInt64}) = 12
@inline Rx2_3_0(::Type{UInt64}) = 31
@inline Rx2_4_0(::Type{UInt64}) = 16
@inline Rx2_5_0(::Type{UInt64}) = 32
@inline Rx2_6_0(::Type{UInt64}) = 24
@inline Rx2_7_0(::Type{UInt64}) = 21

@inline Rx4_0_0(::Type{UInt32}) = 10
@inline Rx4_0_1(::Type{UInt32}) = 26
@inline Rx4_1_0(::Type{UInt32}) = 11
@inline Rx4_1_1(::Type{UInt32}) = 21
@inline Rx4_2_0(::Type{UInt32}) = 13
@inline Rx4_2_1(::Type{UInt32}) = 27
@inline Rx4_3_0(::Type{UInt32}) = 23
@inline Rx4_3_1(::Type{UInt32}) =  5
@inline Rx4_4_0(::Type{UInt32}) =  6
@inline Rx4_4_1(::Type{UInt32}) = 20
@inline Rx4_5_0(::Type{UInt32}) = 17
@inline Rx4_5_1(::Type{UInt32}) = 11
@inline Rx4_6_0(::Type{UInt32}) = 25
@inline Rx4_6_1(::Type{UInt32}) = 10
@inline Rx4_7_0(::Type{UInt32}) = 18
@inline Rx4_7_1(::Type{UInt32}) = 20
@inline Rx2_0_0(::Type{UInt32}) = 13
@inline Rx2_1_0(::Type{UInt32}) = 15
@inline Rx2_2_0(::Type{UInt32}) = 26
@inline Rx2_3_0(::Type{UInt32}) =  6
@inline Rx2_4_0(::Type{UInt32}) = 17
@inline Rx2_5_0(::Type{UInt32}) = 29
@inline Rx2_6_0(::Type{UInt32}) = 16
@inline Rx2_7_0(::Type{UInt32}) = 24

"""
```julia
Threefry2x{T, R} <: R123Generator2x{T}
Threefry2x([seed, R])
Threefry2x(T[, seed, R])
```

Threefry2x is one kind of Threefry Counter-Based RNGs. It generates two numbers at a time.

`T` is `UInt32` or `UInt64`(default).

`seed` is a `Tuple` of two `Integer`s which will both be automatically converted to `T`.

`R` denotes to the Rounds which must be at least 1 and no more than 32. With 20 rounds (by default), it has a
considerable safety margin over the minimum number of rounds with no known statistical flaws, but still has
excellent performance.
"""
mutable struct Threefry2x{T<:Union{UInt32, UInt64}, R} <: R123Generator2x{T}
    x1::T
    x2::T
    key1::T
    key2::T
    ctr1::T
    ctr2::T
    p::Int
end

function Threefry2x(::Type{T}=UInt64, seed::NTuple{2, Integer}=gen_seed(T, 2), R::Integer=20) where
        T <: Union{UInt32, UInt64}
    @assert 1 <= R <= 32
    r = Threefry2x{T, Int(R)}(0, 0, 0, 0, 0, 0, 0)
    seed!(r, seed)
end
Threefry2x(seed::NTuple{2, Integer}, R::Integer=20) = Threefry2x(UInt64, seed, R)

function seed!(r::Threefry2x{T}, seed::NTuple{2, Integer}=gen_seed(T, 2)) where T <: Union{UInt32, UInt64}
    r.x1 = r.x2 = 0
    r.key1 = seed[1] % T
    r.key2 = seed[2] % T
    r.ctr1 = r.ctr2 = 0
    random123_r(r)
    r
end

@inline seed_type(::Type{Threefry2x{T, R}}) where {T, R} = NTuple{2, T}

function copyto!(dest::Threefry2x{T, R}, src::Threefry2x{T, R}) where {T, R}
    unsafe_copyto!(dest, src, T, 6)
    dest.p = src.p
    dest
end

copy(src::Threefry2x{T, R}) where {T, R} = Threefry2x{T, R}(src.x1, src.x2, src.key1, src.key2,
                                                            src.ctr1, src.ctr2, src.p)

==(r1::Threefry2x{T, R}, r2::Threefry2x{T, R}) where {T, R} = unsafe_compare(r1, r2, T, 6) && r1.p == r2.p

@inline get_key(r::Threefry2x) = (r.key1, r.key2)
@inline get_ctr(r::Threefry2x) = (r.ctr1, r.ctr2)
@inline function random123_r(r::Threefry2x{T, R}) where {T <: Union{UInt32, UInt64}, R}
    r.x1, r.x2 = threefry(get_key(r), get_ctr(r), Val(R))
end

"""
    threefry(key::NTuple{2,T}, ctr::NTuple{2,T}, ::Val{R})::NTuple{2,T}
    threefry(key::NTuple{4,T}, ctr::NTuple{4,T}, ::Val{R})::NTuple{4,T}

Functional variant of [`Threefry2x`](@ref) and [`Threefry4x`](@ref). 
Produces a pseudorandom output of type `T = UInt64` or `T = UInt32` from the inputs.
This function if free of mutability and side effects.
"""
@inline function threefry(key::NTuple{2,T}, ctr::NTuple{2,T}, ::Val{R})::NTuple{2,T} where {T <: Union{UInt32, UInt64}, R}
    ks2 = SKEIN_KS_PARITY(T)
    x0,x1 = ctr
    ks0,ks1 = key
    ks2 ⊻= ks0
    ks2 ⊻= ks1
    x0 += ks0
    x1 += ks1

    if R > 0 x0 += x1; x1 = threefry_rotl(x1, Rx2_0_0(T)); x1 ⊻= x0; end
    if R > 1 x0 += x1; x1 = threefry_rotl(x1, Rx2_1_0(T)); x1 ⊻= x0; end
    if R > 2 x0 += x1; x1 = threefry_rotl(x1, Rx2_2_0(T)); x1 ⊻= x0; end
    if R > 3 x0 += x1; x1 = threefry_rotl(x1, Rx2_3_0(T)); x1 ⊻= x0; end
    if R > 3
        x0 += ks1; x1 += ks2;
        x1 += 1 % T;
    end
    if R > 4 x0 += x1; x1 = threefry_rotl(x1, Rx2_4_0(T)); x1 ⊻= x0; end
    if R > 5 x0 += x1; x1 = threefry_rotl(x1, Rx2_5_0(T)); x1 ⊻= x0; end
    if R > 6 x0 += x1; x1 = threefry_rotl(x1, Rx2_6_0(T)); x1 ⊻= x0; end
    if R > 7 x0 += x1; x1 = threefry_rotl(x1, Rx2_7_0(T)); x1 ⊻= x0; end
    if R > 7
        x0 += ks2; x1 += ks0;
        x1 += 2 % T;
    end
    if R > 8 x0 += x1; x1 = threefry_rotl(x1, Rx2_0_0(T)); x1 ⊻= x0; end
    if R > 9 x0 += x1; x1 = threefry_rotl(x1, Rx2_1_0(T)); x1 ⊻= x0; end
    if R > 10 x0 += x1; x1 = threefry_rotl(x1, Rx2_2_0(T)); x1 ⊻= x0; end
    if R > 11 x0 += x1; x1 = threefry_rotl(x1, Rx2_3_0(T)); x1 ⊻= x0; end
    if R > 11
        x0 += ks0; x1 += ks1;
        x1 += 3 % T;
    end
    if R > 12 x0 += x1; x1 = threefry_rotl(x1, Rx2_4_0(T)); x1 ⊻= x0; end
    if R > 13 x0 += x1; x1 = threefry_rotl(x1, Rx2_5_0(T)); x1 ⊻= x0; end
    if R > 14 x0 += x1; x1 = threefry_rotl(x1, Rx2_6_0(T)); x1 ⊻= x0; end
    if R > 15 x0 += x1; x1 = threefry_rotl(x1, Rx2_7_0(T)); x1 ⊻= x0; end
    if R > 15
        x0 += ks1; x1 += ks2;
        x1 += 4 % T;
    end
    if R > 16 x0 += x1; x1 = threefry_rotl(x1, Rx2_0_0(T)); x1 ⊻= x0; end
    if R > 17 x0 += x1; x1 = threefry_rotl(x1, Rx2_1_0(T)); x1 ⊻= x0; end
    if R > 18 x0 += x1; x1 = threefry_rotl(x1, Rx2_2_0(T)); x1 ⊻= x0; end
    if R > 19 x0 += x1; x1 = threefry_rotl(x1, Rx2_3_0(T)); x1 ⊻= x0; end
    if R > 19
        x0 += ks2; x1 += ks0;
        x1 += 5 % T;
    end
    if R > 20 x0 += x1; x1 = threefry_rotl(x1, Rx2_4_0(T)); x1 ⊻= x0; end
    if R > 21 x0 += x1; x1 = threefry_rotl(x1, Rx2_5_0(T)); x1 ⊻= x0; end
    if R > 22 x0 += x1; x1 = threefry_rotl(x1, Rx2_6_0(T)); x1 ⊻= x0; end
    if R > 23 x0 += x1; x1 = threefry_rotl(x1, Rx2_7_0(T)); x1 ⊻= x0; end
    if R > 23
        x0 += ks0; x1 += ks1;
        x1 += 6 % T;
    end
    if R > 24 x0 += x1; x1 = threefry_rotl(x1, Rx2_0_0(T)); x1 ⊻= x0; end
    if R > 25 x0 += x1; x1 = threefry_rotl(x1, Rx2_1_0(T)); x1 ⊻= x0; end
    if R > 26 x0 += x1; x1 = threefry_rotl(x1, Rx2_2_0(T)); x1 ⊻= x0; end
    if R > 27 x0 += x1; x1 = threefry_rotl(x1, Rx2_3_0(T)); x1 ⊻= x0; end
    if R > 27
        x0 += ks1; x1 += ks2;
        x1 += 7 % T;
    end
    if R > 28 x0 += x1; x1 = threefry_rotl(x1, Rx2_4_0(T)); x1 ⊻= x0; end
    if R > 29 x0 += x1; x1 = threefry_rotl(x1, Rx2_5_0(T)); x1 ⊻= x0; end
    if R > 30 x0 += x1; x1 = threefry_rotl(x1, Rx2_6_0(T)); x1 ⊻= x0; end
    if R > 31 x0 += x1; x1 = threefry_rotl(x1, Rx2_7_0(T)); x1 ⊻= x0; end
    if R > 31
        x0 += ks2; x1 += ks0;
        x1 += 8 % T;
    end
    x0, x1
end

"""
```julia
Threefry4x{T, R} <: R123Generator4x{T}
Threefry4x([seed, R])
Threefry4x(T[, seed, R])
```

Threefry2x is one kind of Threefry Counter-Based RNGs. It generates four numbers at a time.

`T` is `UInt32` or `UInt64`(default).

`seed` is a `Tuple` of four `Integer`s which will all be automatically converted to `T`.

`R` denotes to the Rounds which must be at least 1 and no more than 32. With 20 rounds (by default), it has a
considerable safety margin over the minimum number of rounds with no known statistical flaws, but still has
excellent performance.
"""
mutable struct Threefry4x{T<:Union{UInt32, UInt64}, R} <: R123Generator4x{T}
    x1::T
    x2::T
    x3::T
    x4::T
    key1::T
    key2::T
    key3::T
    key4::T
    ctr1::T
    ctr2::T
    ctr3::T
    ctr4::T
    p::Int
end

function Threefry4x(::Type{T}=UInt64, seed::NTuple{4, Integer}=gen_seed(T, 4), R::Integer=20) where
        T <: Union{UInt32, UInt64}
    @assert 1 <= R <= 72
    r = Threefry4x{T, Int(R)}(0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)
    seed!(r, seed)
end
Threefry4x(seed::NTuple{4, Integer}, R::Integer=20) = Threefry4x(UInt64, seed, R)

function seed!(r::Threefry4x{T}, seed::NTuple{4, Integer}=gen_seed(T, 4)) where T <: Union{UInt32, UInt64}
    r.x1 = r.x2 = r.x3 = r.x4 = 0
    r.key1, r.key2, r.key3, r.key4 = seed[1] % T, seed[2] % T, seed[3] % T, seed[4] % T
    r.ctr1 = r.ctr2 = r.ctr3 = r.ctr4 = 0
    random123_r(r)
    r
end

@inline seed_type(::Type{Threefry4x{T, R}}) where {T, R} = NTuple{4, T}

function copyto!(dest::Threefry4x{T, R}, src::Threefry4x{T, R}) where {T, R}
    unsafe_copyto!(dest, src, T, 12)
    dest.p = src.p
    dest
end

copy(src::Threefry4x{T, R}) where {T, R} = Threefry4x{T, R}(src.x1, src.x2, src.x3, src.x4,
                                                     src.key1, src.key2, src.key3, src.key4,
                                                     src.ctr1, src.ctr2, src.ctr3, src.ctr4, src.p)

==(r1::Threefry4x{T, R}, r2::Threefry4x{T, R}) where {T, R} = unsafe_compare(r1, r2, T, 12) && r1.p == r2.p

@inline get_key(r::Threefry4x) = (r.key1, r.key2, r.key3, r.key4)
@inline get_ctr(r::Threefry4x) = (r.ctr1, r.ctr2, r.ctr3, r.ctr4)

@inline function random123_r(r::Threefry4x{T, R}) where {T <: Union{UInt32, UInt64}, R}
    r.x1, r.x2, r.x3, r.x4 = threefry(get_key(r), get_ctr(r), Val(R))
end

@inline function threefry(key::NTuple{4,T},ctr::NTuple{4,T}, rounds::Val{R})::NTuple{4,T} where {T <: Union{UInt32, UInt64}, R}
    ks4 = SKEIN_KS_PARITY(T)
    ks0,ks1,ks2,ks3 = key
    x0,x1,x2,x3 = ctr
    ks4 ⊻= ks0
    ks4 ⊻= ks1
    ks4 ⊻= ks2
    ks4 ⊻= ks3
    x0 += ks0; x1 += ks1; x2 += ks2; x3 += ks3;

    if R > 0
        x0 += x1; x1 = threefry_rotl(x1, Rx4_0_0(T)); x1 ⊻= x0;
        x2 += x3; x3 = threefry_rotl(x3, Rx4_0_1(T)); x3 ⊻= x2;
    end
    if R > 1
        x0 += x3; x3 = threefry_rotl(x3, Rx4_1_0(T)); x3 ⊻= x0;
        x2 += x1; x1 = threefry_rotl(x1, Rx4_1_1(T)); x1 ⊻= x2;
    end
    if R > 2
        x0 += x1; x1 = threefry_rotl(x1, Rx4_2_0(T)); x1 ⊻= x0;
        x2 += x3; x3 = threefry_rotl(x3, Rx4_2_1(T)); x3 ⊻= x2;
    end
    if R > 3
        x0 += x3; x3 = threefry_rotl(x3, Rx4_3_0(T)); x3 ⊻= x0;
        x2 += x1; x1 = threefry_rotl(x1, Rx4_3_1(T)); x1 ⊻= x2;
    end
    if R > 3
        x0 += ks1; x1 += ks2; x2 += ks3; x3 += ks4;
        x3 += 1 % T;
    end
    if R > 4
        x0 += x1; x1 = threefry_rotl(x1, Rx4_4_0(T)); x1 ⊻= x0;
        x2 += x3; x3 = threefry_rotl(x3, Rx4_4_1(T)); x3 ⊻= x2;
    end
    if R > 5
        x0 += x3; x3 = threefry_rotl(x3, Rx4_5_0(T)); x3 ⊻= x0;
        x2 += x1; x1 = threefry_rotl(x1, Rx4_5_1(T)); x1 ⊻= x2;
    end
    if R > 6
        x0 += x1; x1 = threefry_rotl(x1, Rx4_6_0(T)); x1 ⊻= x0;
        x2 += x3; x3 = threefry_rotl(x3, Rx4_6_1(T)); x3 ⊻= x2;
    end
    if R > 7
        x0 += x3; x3 = threefry_rotl(x3, Rx4_7_0(T)); x3 ⊻= x0;
        x2 += x1; x1 = threefry_rotl(x1, Rx4_7_1(T)); x1 ⊻= x2;
    end
    if R > 7
        x0 += ks2; x1 += ks3; x2 += ks4; x3 += ks0;
        x3 += 2 % T;
    end
    if R > 8
        x0 += x1; x1 = threefry_rotl(x1, Rx4_0_0(T)); x1 ⊻= x0;
        x2 += x3; x3 = threefry_rotl(x3, Rx4_0_1(T)); x3 ⊻= x2;
    end
    if R > 9
        x0 += x3; x3 = threefry_rotl(x3, Rx4_1_0(T)); x3 ⊻= x0;
        x2 += x1; x1 = threefry_rotl(x1, Rx4_1_1(T)); x1 ⊻= x2;
    end
    if R > 10
        x0 += x1; x1 = threefry_rotl(x1, Rx4_2_0(T)); x1 ⊻= x0;
        x2 += x3; x3 = threefry_rotl(x3, Rx4_2_1(T)); x3 ⊻= x2;
    end
    if R > 11
        x0 += x3; x3 = threefry_rotl(x3, Rx4_3_0(T)); x3 ⊻= x0;
        x2 += x1; x1 = threefry_rotl(x1, Rx4_3_1(T)); x1 ⊻= x2;
    end
    if R > 11
        x0 += ks3; x1 += ks4; x2 += ks0; x3 += ks1;
        x3 += 3 % T;
    end
    if R > 12
        x0 += x1; x1 = threefry_rotl(x1, Rx4_4_0(T)); x1 ⊻= x0;
        x2 += x3; x3 = threefry_rotl(x3, Rx4_4_1(T)); x3 ⊻= x2;
    end
    if R > 13
        x0 += x3; x3 = threefry_rotl(x3, Rx4_5_0(T)); x3 ⊻= x0;
        x2 += x1; x1 = threefry_rotl(x1, Rx4_5_1(T)); x1 ⊻= x2;
    end
    if R > 14
        x0 += x1; x1 = threefry_rotl(x1, Rx4_6_0(T)); x1 ⊻= x0;
        x2 += x3; x3 = threefry_rotl(x3, Rx4_6_1(T)); x3 ⊻= x2;
    end
    if R > 15
        x0 += x3; x3 = threefry_rotl(x3, Rx4_7_0(T)); x3 ⊻= x0;
        x2 += x1; x1 = threefry_rotl(x1, Rx4_7_1(T)); x1 ⊻= x2;
    end
    if R > 15
        x0 += ks4; x1 += ks0; x2 += ks1; x3 += ks2;
        x3 += 4 % T;
    end
    if R > 16
        x0 += x1; x1 = threefry_rotl(x1, Rx4_0_0(T)); x1 ⊻= x0;
        x2 += x3; x3 = threefry_rotl(x3, Rx4_0_1(T)); x3 ⊻= x2;
    end
    if R > 17
        x0 += x3; x3 = threefry_rotl(x3, Rx4_1_0(T)); x3 ⊻= x0;
        x2 += x1; x1 = threefry_rotl(x1, Rx4_1_1(T)); x1 ⊻= x2;
    end
    if R > 18
        x0 += x1; x1 = threefry_rotl(x1, Rx4_2_0(T)); x1 ⊻= x0;
        x2 += x3; x3 = threefry_rotl(x3, Rx4_2_1(T)); x3 ⊻= x2;
    end
    if R > 19
        x0 += x3; x3 = threefry_rotl(x3, Rx4_3_0(T)); x3 ⊻= x0;
        x2 += x1; x1 = threefry_rotl(x1, Rx4_3_1(T)); x1 ⊻= x2;
    end
    if R > 19
        x0 += ks0; x1 += ks1; x2 += ks2; x3 += ks3;
        x3 += 5 % T;
    end
    if R > 20
        x0 += x1; x1 = threefry_rotl(x1, Rx4_4_0(T)); x1 ⊻= x0;
        x2 += x3; x3 = threefry_rotl(x3, Rx4_4_1(T)); x3 ⊻= x2;
    end
    if R > 21
        x0 += x3; x3 = threefry_rotl(x3, Rx4_5_0(T)); x3 ⊻= x0;
        x2 += x1; x1 = threefry_rotl(x1, Rx4_5_1(T)); x1 ⊻= x2;
    end
    if R > 22
        x0 += x1; x1 = threefry_rotl(x1, Rx4_6_0(T)); x1 ⊻= x0;
        x2 += x3; x3 = threefry_rotl(x3, Rx4_6_1(T)); x3 ⊻= x2;
    end
    if R > 23
        x0 += x3; x3 = threefry_rotl(x3, Rx4_7_0(T)); x3 ⊻= x0;
        x2 += x1; x1 = threefry_rotl(x1, Rx4_7_1(T)); x1 ⊻= x2;
    end
    if R > 23
        x0 += ks1; x1 += ks2; x2 += ks3; x3 += ks4;
        x3 += 6 % T;
    end
    if R > 24
        x0 += x1; x1 = threefry_rotl(x1, Rx4_0_0(T)); x1 ⊻= x0;
        x2 += x3; x3 = threefry_rotl(x3, Rx4_0_1(T)); x3 ⊻= x2;
    end
    if R > 25
        x0 += x3; x3 = threefry_rotl(x3, Rx4_1_0(T)); x3 ⊻= x0;
        x2 += x1; x1 = threefry_rotl(x1, Rx4_1_1(T)); x1 ⊻= x2;
    end
    if R > 26
        x0 += x1; x1 = threefry_rotl(x1, Rx4_2_0(T)); x1 ⊻= x0;
        x2 += x3; x3 = threefry_rotl(x3, Rx4_2_1(T)); x3 ⊻= x2;
    end
    if R > 27
        x0 += x3; x3 = threefry_rotl(x3, Rx4_3_0(T)); x3 ⊻= x0;
        x2 += x1; x1 = threefry_rotl(x1, Rx4_3_1(T)); x1 ⊻= x2;
    end
    if R > 27
        x0 += ks2; x1 += ks3; x2 += ks4; x3 += ks0;
        x3 += 7 % T;
    end
    if R > 28
        x0 += x1; x1 = threefry_rotl(x1, Rx4_4_0(T)); x1 ⊻= x0;
        x2 += x3; x3 = threefry_rotl(x3, Rx4_4_1(T)); x3 ⊻= x2;
    end
    if R > 29
        x0 += x3; x3 = threefry_rotl(x3, Rx4_5_0(T)); x3 ⊻= x0;
        x2 += x1; x1 = threefry_rotl(x1, Rx4_5_1(T)); x1 ⊻= x2;
    end
    if R > 30
        x0 += x1; x1 = threefry_rotl(x1, Rx4_6_0(T)); x1 ⊻= x0;
        x2 += x3; x3 = threefry_rotl(x3, Rx4_6_1(T)); x3 ⊻= x2;
    end
    if R > 31
        x0 += x3; x3 = threefry_rotl(x3, Rx4_7_0(T)); x3 ⊻= x0;
        x2 += x1; x1 = threefry_rotl(x1, Rx4_7_1(T)); x1 ⊻= x2;
    end
    if R > 31
        x0 += ks3; x1 += ks4; x2 += ks0; x3 += ks1;
        x3 += 8 % T;
    end
    if R > 32
        x0 += x1; x1 = threefry_rotl(x1, Rx4_0_0(T)); x1 ⊻= x0;
        x2 += x3; x3 = threefry_rotl(x3, Rx4_0_1(T)); x3 ⊻= x2;
    end
    if R > 33
        x0 += x3; x3 = threefry_rotl(x3, Rx4_1_0(T)); x3 ⊻= x0;
        x2 += x1; x1 = threefry_rotl(x1, Rx4_1_1(T)); x1 ⊻= x2;
    end
    if R > 34
        x0 += x1; x1 = threefry_rotl(x1, Rx4_2_0(T)); x1 ⊻= x0;
        x2 += x3; x3 = threefry_rotl(x3, Rx4_2_1(T)); x3 ⊻= x2;
    end
    if R > 35
        x0 += x3; x3 = threefry_rotl(x3, Rx4_3_0(T)); x3 ⊻= x0;
        x2 += x1; x1 = threefry_rotl(x1, Rx4_3_1(T)); x1 ⊻= x2;
    end
    if R > 35
        x0 += ks4; x1 += ks0; x2 += ks1; x3 += ks2;
        x3 += 9 % T;
    end
    if R > 36
        x0 += x1; x1 = threefry_rotl(x1, Rx4_4_0(T)); x1 ⊻= x0;
        x2 += x3; x3 = threefry_rotl(x3, Rx4_4_1(T)); x3 ⊻= x2;
    end
    if R > 37
        x0 += x3; x3 = threefry_rotl(x3, Rx4_5_0(T)); x3 ⊻= x0;
        x2 += x1; x1 = threefry_rotl(x1, Rx4_5_1(T)); x1 ⊻= x2;
    end
    if R > 38
        x0 += x1; x1 = threefry_rotl(x1, Rx4_6_0(T)); x1 ⊻= x0;
        x2 += x3; x3 = threefry_rotl(x3, Rx4_6_1(T)); x3 ⊻= x2;
    end
    if R > 39
        x0 += x3; x3 = threefry_rotl(x3, Rx4_7_0(T)); x3 ⊻= x0;
        x2 += x1; x1 = threefry_rotl(x1, Rx4_7_1(T)); x1 ⊻= x2;
    end
    if R > 39
        x0 += ks0; x1 += ks1; x2 += ks2; x3 += ks3;
        x3 += 10 % T;
    end
    if R > 40
        x0 += x1; x1 = threefry_rotl(x1, Rx4_0_0(T)); x1 ⊻= x0;
        x2 += x3; x3 = threefry_rotl(x3, Rx4_0_1(T)); x3 ⊻= x2;
    end
    if R > 41
        x0 += x3; x3 = threefry_rotl(x3, Rx4_1_0(T)); x3 ⊻= x0;
        x2 += x1; x1 = threefry_rotl(x1, Rx4_1_1(T)); x1 ⊻= x2;
    end
    if R > 42
        x0 += x1; x1 = threefry_rotl(x1, Rx4_2_0(T)); x1 ⊻= x0;
        x2 += x3; x3 = threefry_rotl(x3, Rx4_2_1(T)); x3 ⊻= x2;
    end
    if R > 43
        x0 += x3; x3 = threefry_rotl(x3, Rx4_3_0(T)); x3 ⊻= x0;
        x2 += x1; x1 = threefry_rotl(x1, Rx4_3_1(T)); x1 ⊻= x2;
    end
    if R > 43
        x0 += ks1; x1 += ks2; x2 += ks3; x3 += ks4;
        x3 += 11 % T;
    end
    if R > 44
        x0 += x1; x1 = threefry_rotl(x1, Rx4_4_0(T)); x1 ⊻= x0;
        x2 += x3; x3 = threefry_rotl(x3, Rx4_4_1(T)); x3 ⊻= x2;
    end
    if R > 45
        x0 += x3; x3 = threefry_rotl(x3, Rx4_5_0(T)); x3 ⊻= x0;
        x2 += x1; x1 = threefry_rotl(x1, Rx4_5_1(T)); x1 ⊻= x2;
    end
    if R > 46
        x0 += x1; x1 = threefry_rotl(x1, Rx4_6_0(T)); x1 ⊻= x0;
        x2 += x3; x3 = threefry_rotl(x3, Rx4_6_1(T)); x3 ⊻= x2;
    end
    if R > 47
        x0 += x3; x3 = threefry_rotl(x3, Rx4_7_0(T)); x3 ⊻= x0;
        x2 += x1; x1 = threefry_rotl(x1, Rx4_7_1(T)); x1 ⊻= x2;
    end
    if R > 47
        x0 += ks2; x1 += ks3; x2 += ks4; x3 += ks0;
        x3 += 12 % T;
    end
    if R > 48
        x0 += x1; x1 = threefry_rotl(x1, Rx4_0_0(T)); x1 ⊻= x0;
        x2 += x3; x3 = threefry_rotl(x3, Rx4_0_1(T)); x3 ⊻= x2;
    end
    if R > 49
        x0 += x3; x3 = threefry_rotl(x3, Rx4_1_0(T)); x3 ⊻= x0;
        x2 += x1; x1 = threefry_rotl(x1, Rx4_1_1(T)); x1 ⊻= x2;
    end
    if R > 50
        x0 += x1; x1 = threefry_rotl(x1, Rx4_2_0(T)); x1 ⊻= x0;
        x2 += x3; x3 = threefry_rotl(x3, Rx4_2_1(T)); x3 ⊻= x2;
    end
    if R > 51
        x0 += x3; x3 = threefry_rotl(x3, Rx4_3_0(T)); x3 ⊻= x0;
        x2 += x1; x1 = threefry_rotl(x1, Rx4_3_1(T)); x1 ⊻= x2;
    end
    if R > 51
        x0 += ks3; x1 += ks4; x2 += ks0; x3 += ks1;
        x3 += 13 % T;
    end
    if R > 52
        x0 += x1; x1 = threefry_rotl(x1, Rx4_4_0(T)); x1 ⊻= x0;
        x2 += x3; x3 = threefry_rotl(x3, Rx4_4_1(T)); x3 ⊻= x2;
    end
    if R > 53
        x0 += x3; x3 = threefry_rotl(x3, Rx4_5_0(T)); x3 ⊻= x0;
        x2 += x1; x1 = threefry_rotl(x1, Rx4_5_1(T)); x1 ⊻= x2;
    end
    if R > 54
        x0 += x1; x1 = threefry_rotl(x1, Rx4_6_0(T)); x1 ⊻= x0;
        x2 += x3; x3 = threefry_rotl(x3, Rx4_6_1(T)); x3 ⊻= x2;
    end
    if R > 55
        x0 += x3; x3 = threefry_rotl(x3, Rx4_7_0(T)); x3 ⊻= x0;
        x2 += x1; x1 = threefry_rotl(x1, Rx4_7_1(T)); x1 ⊻= x2;
    end
    if R > 55
        x0 += ks4; x1 += ks0; x2 += ks1; x3 += ks2;
        x3 += 14 % T;
    end
    if R > 56
        x0 += x1; x1 = threefry_rotl(x1, Rx4_0_0(T)); x1 ⊻= x0;
        x2 += x3; x3 = threefry_rotl(x3, Rx4_0_1(T)); x3 ⊻= x2;
    end
    if R > 57
        x0 += x3; x3 = threefry_rotl(x3, Rx4_1_0(T)); x3 ⊻= x0;
        x2 += x1; x1 = threefry_rotl(x1, Rx4_1_1(T)); x1 ⊻= x2;
    end
    if R > 58
        x0 += x1; x1 = threefry_rotl(x1, Rx4_2_0(T)); x1 ⊻= x0;
        x2 += x3; x3 = threefry_rotl(x3, Rx4_2_1(T)); x3 ⊻= x2;
    end
    if R > 59
        x0 += x3; x3 = threefry_rotl(x3, Rx4_3_0(T)); x3 ⊻= x0;
        x2 += x1; x1 = threefry_rotl(x1, Rx4_3_1(T)); x1 ⊻= x2;
    end
    if R > 59
        x0 += ks0; x1 += ks1; x2 += ks2; x3 += ks3;
        x3 += 15 % T;
    end
    if R > 60
        x0 += x1; x1 = threefry_rotl(x1, Rx4_4_0(T)); x1 ⊻= x0;
        x2 += x3; x3 = threefry_rotl(x3, Rx4_4_1(T)); x3 ⊻= x2;
    end
    if R > 61
        x0 += x3; x3 = threefry_rotl(x3, Rx4_5_0(T)); x3 ⊻= x0;
        x2 += x1; x1 = threefry_rotl(x1, Rx4_5_1(T)); x1 ⊻= x2;
    end
    if R > 62
        x0 += x1; x1 = threefry_rotl(x1, Rx4_6_0(T)); x1 ⊻= x0;
        x2 += x3; x3 = threefry_rotl(x3, Rx4_6_1(T)); x3 ⊻= x2;
    end
    if R > 63
        x0 += x3; x3 = threefry_rotl(x3, Rx4_7_0(T)); x3 ⊻= x0;
        x2 += x1; x1 = threefry_rotl(x1, Rx4_7_1(T)); x1 ⊻= x2;
    end
    if R > 63
        x0 += ks1; x1 += ks2; x2 += ks3; x3 += ks4;
        x3 += 16 % T;
    end
    if R > 64
        x0 += x1; x1 = threefry_rotl(x1, Rx4_0_0(T)); x1 ⊻= x0;
        x2 += x3; x3 = threefry_rotl(x3, Rx4_0_1(T)); x3 ⊻= x2;
    end
    if R > 65
        x0 += x3; x3 = threefry_rotl(x3, Rx4_1_0(T)); x3 ⊻= x0;
        x2 += x1; x1 = threefry_rotl(x1, Rx4_1_1(T)); x1 ⊻= x2;
    end
    if R > 66
        x0 += x1; x1 = threefry_rotl(x1, Rx4_2_0(T)); x1 ⊻= x0;
        x2 += x3; x3 = threefry_rotl(x3, Rx4_2_1(T)); x3 ⊻= x2;
    end
    if R > 67
        x0 += x3; x3 = threefry_rotl(x3, Rx4_3_0(T)); x3 ⊻= x0;
        x2 += x1; x1 = threefry_rotl(x1, Rx4_3_1(T)); x1 ⊻= x2;
    end
    if R > 67
        x0 += ks2; x1 += ks3; x2 += ks4; x3 += ks0;
        x3 += 17 % T;
    end
    if R > 68
        x0 += x1; x1 = threefry_rotl(x1, Rx4_4_0(T)); x1 ⊻= x0;
        x2 += x3; x3 = threefry_rotl(x3, Rx4_4_1(T)); x3 ⊻= x2;
    end
    if R > 69
        x0 += x3; x3 = threefry_rotl(x3, Rx4_5_0(T)); x3 ⊻= x0;
        x2 += x1; x1 = threefry_rotl(x1, Rx4_5_1(T)); x1 ⊻= x2;
    end
    if R > 70
        x0 += x1; x1 = threefry_rotl(x1, Rx4_6_0(T)); x1 ⊻= x0;
        x2 += x3; x3 = threefry_rotl(x3, Rx4_6_1(T)); x3 ⊻= x2;
    end
    if R > 71
        x0 += x3; x3 = threefry_rotl(x3, Rx4_7_0(T)); x3 ⊻= x0;
        x2 += x1; x1 = threefry_rotl(x1, Rx4_7_1(T)); x1 ⊻= x2;
    end
    if R > 71
        x0 += ks3; x1 += ks4; x2 += ks0; x3 += ks1;
        x3 += 18 % T;
    end
    x0, x1, x2, x3
end

import Random: seed!
using Test: @test, @testset

using RandomNumbers
using Random123

import RandomNumbers: split_uint
import Random123: uint64x2, AESNIKey

@testset "Accelerated AESNI" begin
    x = zero(uint64x2)
    ctr = uint64x2(0x9799b5d54f7b9227b47607190d0dfefb)
    key = 0x07b8e4b6aa98ec245a7da274d3b8146a
    aesni_key = AESNIKey(key)
    @test rand(AESNI1x(x, ctr, aesni_key), UInt128) ≡ 0x60f4c27fe48fe1b8c5f4568a585b0dc0

    r = AESNI1x(key)
    r1 = AESNI4x(split_uint(key, UInt32))
    @test seed_type(r) ≡ UInt128
    @test seed_type(r1) ≡ NTuple{4, UInt32}
    @test copyto!(copy(r), r) == r
    @test copyto!(copy(r1), r1) == r1
    @test UInt128(r.x) ≡ rand(r1, UInt128)
    @test rand(r, UInt128) ≡ rand(r1, UInt128)
    set_counter!(r, 0)
    set_counter!(r1, 1)
    @test rand(r, Tuple{UInt128})[1] ≡ rand(r1, UInt128)
end

import Base: copy, copyto!, ==
import Random: seed!
import RandomNumbers: gen_seed, seed_type, unsafe_copyto!, unsafe_compare

for (w, T, Td) in ((32, UInt32, UInt64), (64, UInt64, UInt128))
    @eval @inline function philox_mulhilo(a::$T, b::$T)
        product = (a % $Td) * (b % $Td)
        hi = (product >> $w) % $T
        lo = product % $T
        (hi, lo)
    end
end

@inline PHILOX_M2x_0(::Type{UInt64}) = 0xD2B74407B1CE6E93
@inline PHILOX_M4x_0(::Type{UInt64}) = 0xD2E7470EE14C6C93
@inline PHILOX_M4x_1(::Type{UInt64}) = 0xCA5A826395121157

@inline PHILOX_M2x_0(::Type{UInt32}) = 0xd256d193
@inline PHILOX_M4x_0(::Type{UInt32}) = 0xD2511F53
@inline PHILOX_M4x_1(::Type{UInt32}) = 0xCD9E8D57

@inline PHILOX_W_0(::Type{UInt64}) = 0x9E3779B97F4A7C15
@inline PHILOX_W_1(::Type{UInt64}) = 0xBB67AE8584CAA73B

@inline PHILOX_W_0(::Type{UInt32}) = 0x9E3779B9
@inline PHILOX_W_1(::Type{UInt32}) = 0xBB67AE85


"""
```julia
Philox2x{T, R} <: R123Generator2x{T}
Philox2x([seed, R])
Philox2x(T[, seed, R])
```

Philox2x is one kind of Philox Counter-Based RNGs. It generates two numbers at a time.

`T` is `UInt32` or `UInt64`(default).

`seed` is an `Integer` which will be automatically converted to `T`.

`R` denotes to the Rounds which must be at least 1 and no more than 16. With 10 rounds (by default), it has a
considerable safety margin over the minimum number of rounds with no known statistical flaws, but still has
excellent performance.
"""
mutable struct Philox2x{T<:Union{UInt32, UInt64}, R} <: R123Generator2x{T}
    x1::T
    x2::T
    key::T
    ctr1::T
    ctr2::T
    p::Int
end

function Philox2x(::Type{T}=UInt64, seed::Integer=gen_seed(T), R::Integer=10) where T <: Union{UInt32, UInt64}
    @assert 1 <= R <= 16
    r = Philox2x{T, Int(R)}(0, 0, 0, 0, 0, 0)
    seed!(r, seed)
end
Philox2x(seed::Integer, R::Integer=10) = Philox2x(UInt64, seed, R)

function seed!(r::Philox2x{T}, seed::Integer=gen_seed(T)) where T <: Union{UInt32, UInt64}
    r.x1 = r.x2 = 0
    r.key = seed % T
    r.ctr1 = r.ctr2 = 0
    random123_r(r)
    r.p = 0
    r
end

@inline seed_type(::Type{Philox2x{T, R}}) where {T, R} = T

function copyto!(dest::Philox2x{T, R}, src::Philox2x{T, R}) where {T, R}
    unsafe_copyto!(dest, src, T, 5)
    dest.p = src.p
    dest
end

copy(src::Philox2x{T, R}) where {T, R} = Philox2x{T, R}(src.x1, src.x2, src.key, src.ctr1, src.ctr2, src.p)

==(r1::Philox2x{T, R}, r2::Philox2x{T, R}) where {T, R} = unsafe_compare(r1, r2, T, 5) && r1.p == r2.p

@inline function philox2x_round(ctr1::T, ctr2::T, key::T) where T <: Union{UInt32, UInt64}
    hi, lo = philox_mulhilo(PHILOX_M2x_0(T), ctr1)
    hi ⊻ key ⊻ ctr2, lo
end

@inline function philox2x_bumpkey(key::T) where T <: Union{UInt32, UInt64}
    key + PHILOX_W_0(T)
end

@inline get_key(r::Philox2x) = (r.key,)
@inline get_ctr(r::Philox2x) = (r.ctr1, r.ctr2)

@inline function random123_r(r::Philox2x{T, R}) where {T <: Union{UInt32, UInt64}, R}
    r.x1, r.x2 = philox(get_key(r), get_ctr(r), Val(R))
end

"""
    philox(key::NTuple{1,T}, ctr::NTuple{2,T}, ::Val{R})::NTuple{2,T}
    philox(key::NTuple{2,T}, ctr::NTuple{4,T}, ::Val{R})::NTuple{4,T}

Functional variant of [`Philox2x`](@ref) and [`Philox4x`](@ref). 
Produces a pseudorandom output of type `T = UInt64` or `T = UInt32` from the inputs.
This function if free of mutability and side effects.
"""
@inline function philox(key_::Tuple{T}, ctr::NTuple{2,T}, ::Val{R}) where {T,R}
    key = first(key_)
    ctr1, ctr2 = ctr
    if R > 0                               ctr1, ctr2 = philox2x_round(ctr1, ctr2, key); end
    if R > 1  key = philox2x_bumpkey(key); ctr1, ctr2 = philox2x_round(ctr1, ctr2, key); end
    if R > 2  key = philox2x_bumpkey(key); ctr1, ctr2 = philox2x_round(ctr1, ctr2, key); end
    if R > 3  key = philox2x_bumpkey(key); ctr1, ctr2 = philox2x_round(ctr1, ctr2, key); end
    if R > 4  key = philox2x_bumpkey(key); ctr1, ctr2 = philox2x_round(ctr1, ctr2, key); end
    if R > 5  key = philox2x_bumpkey(key); ctr1, ctr2 = philox2x_round(ctr1, ctr2, key); end
    if R > 6  key = philox2x_bumpkey(key); ctr1, ctr2 = philox2x_round(ctr1, ctr2, key); end
    if R > 7  key = philox2x_bumpkey(key); ctr1, ctr2 = philox2x_round(ctr1, ctr2, key); end
    if R > 8  key = philox2x_bumpkey(key); ctr1, ctr2 = philox2x_round(ctr1, ctr2, key); end
    if R > 9  key = philox2x_bumpkey(key); ctr1, ctr2 = philox2x_round(ctr1, ctr2, key); end
    if R > 10 key = philox2x_bumpkey(key); ctr1, ctr2 = philox2x_round(ctr1, ctr2, key); end
    if R > 11 key = philox2x_bumpkey(key); ctr1, ctr2 = philox2x_round(ctr1, ctr2, key); end
    if R > 12 key = philox2x_bumpkey(key); ctr1, ctr2 = philox2x_round(ctr1, ctr2, key); end
    if R > 13 key = philox2x_bumpkey(key); ctr1, ctr2 = philox2x_round(ctr1, ctr2, key); end
    if R > 14 key = philox2x_bumpkey(key); ctr1, ctr2 = philox2x_round(ctr1, ctr2, key); end
    if R > 15 key = philox2x_bumpkey(key); ctr1, ctr2 = philox2x_round(ctr1, ctr2, key); end
    ctr1, ctr2
end

"""
```julia
Philox4x{T, R} <: R123Generator4x{T}
Philox4x([seed, R])
Philox4x(T[, seed, R])
```

Philox4x is one kind of Philox Counter-Based RNGs. It generates four numbers at a time.

`T` is `UInt32` or `UInt64`(default).

`seed` is a `Tuple` of two `Integer`s which will both be automatically converted to `T`.

`R` denotes to the Rounds which must be at least 1 and no more than 16. With 10 rounds (by default), it has a
considerable safety margin over the minimum number of rounds with no known statistical flaws, but still has
excellent performance.
"""
mutable struct Philox4x{T<:Union{UInt32, UInt64}, R} <: R123Generator4x{T}
    x1::T
    x2::T
    x3::T
    x4::T
    key1::T
    key2::T
    ctr1::T
    ctr2::T
    ctr3::T
    ctr4::T
    p::Int
end

function Philox4x(::Type{T}=UInt64, seed::NTuple{2, Integer}=gen_seed(T, 2), R::Integer=10) where
        T <: Union{UInt32, UInt64}
    @assert 1 <= R <= 16
    r = Philox4x{T, Int(R)}(0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)
    seed!(r, seed)
end
Philox4x(seed::NTuple{2, Integer}, R::Integer=10) = Philox4x(UInt64, seed, R)

function seed!(r::Philox4x{T}, seed::NTuple{2, Integer}=gen_seed(T, 2)) where T <: Union{UInt32, UInt64}
    r.x1 = r.x2 = r.x3 = r.x4 = 0
    r.key1 = seed[1] % T
    r.key2 = seed[2] % T
    r.ctr1 = r.ctr2 = r.ctr3 = r.ctr4 = 0
    random123_r(r)
    r.p = 0
    r
end

@inline seed_type(::Type{Philox4x{T, R}}) where {T, R} = NTuple{2, T}

function copyto!(dest::Philox4x{T, R}, src::Philox4x{T, R}) where {T, R}
    unsafe_copyto!(dest, src, T, 10)
    dest.p = src.p
    dest
end

copy(src::Philox4x{T, R}) where {T, R} = Philox4x{T, R}(src.x1, src.x2, src.x3, src.x4, src.key1, src.key2,
                                                        src.ctr1, src.ctr2, src.ctr3, src.ctr4, src.p)

==(r1::Philox4x{T, R}, r2::Philox4x{T, R}) where {T, R} = unsafe_compare(r1, r2, T, 10)  && r1.p == r2.p

@inline function philox4x_round(ctr1::T, ctr2::T, ctr3::T, ctr4::T, key1::T, key2::T) where
        T <: Union{UInt32, UInt64}
    hi1, lo1 = philox_mulhilo(PHILOX_M4x_0(T), ctr1)
    hi2, lo2 = philox_mulhilo(PHILOX_M4x_1(T), ctr3)
    hi2 ⊻ ctr2 ⊻ key1, lo2, hi1 ⊻ ctr4 ⊻ key2, lo1
end

@inline function philox4x_bumpkey(key1::T, key2::T) where T <: Union{UInt32, UInt64}
    key1 + PHILOX_W_0(T), key2 + PHILOX_W_1(T)
end

@inline get_ctr(r::Philox4x) = (r.ctr1, r.ctr2, r.ctr3, r.ctr4)
@inline get_key(r::Philox4x) = (r.key1, r.key2)
@inline function random123_r(r::Philox4x{T, R}) where {T <: Union{UInt32, UInt64}, R}
    r.x1, r.x2, r.x3, r.x4 = philox(get_key(r), get_ctr(r), Val(R))
end

@inline function philox(key::NTuple{2,T}, ctr::NTuple{4,T}, ::Val{R}) where {T <:Union{UInt32, UInt64}, R}
    ctr1, ctr2, ctr3, ctr4 = ctr
    key1, key2 = key
    if R > 0
        ctr1, ctr2, ctr3, ctr4 = philox4x_round(ctr1, ctr2, ctr3, ctr4, key1, key2);
    end
    if R > 1
        key1, key2 = philox4x_bumpkey(key1, key2);
        ctr1, ctr2, ctr3, ctr4 = philox4x_round(ctr1, ctr2, ctr3, ctr4, key1, key2);
    end
    if R > 2
        key1, key2 = philox4x_bumpkey(key1, key2);
        ctr1, ctr2, ctr3, ctr4 = philox4x_round(ctr1, ctr2, ctr3, ctr4, key1, key2);
    end
    if R > 3
        key1, key2 = philox4x_bumpkey(key1, key2);
        ctr1, ctr2, ctr3, ctr4 = philox4x_round(ctr1, ctr2, ctr3, ctr4, key1, key2);
    end
    if R > 4
        key1, key2 = philox4x_bumpkey(key1, key2);
        ctr1, ctr2, ctr3, ctr4 = philox4x_round(ctr1, ctr2, ctr3, ctr4, key1, key2);
    end
    if R > 5
        key1, key2 = philox4x_bumpkey(key1, key2);
        ctr1, ctr2, ctr3, ctr4 = philox4x_round(ctr1, ctr2, ctr3, ctr4, key1, key2);
    end
    if R > 6
        key1, key2 = philox4x_bumpkey(key1, key2);
        ctr1, ctr2, ctr3, ctr4 = philox4x_round(ctr1, ctr2, ctr3, ctr4, key1, key2);
    end
    if R > 7
        key1, key2 = philox4x_bumpkey(key1, key2);
        ctr1, ctr2, ctr3, ctr4 = philox4x_round(ctr1, ctr2, ctr3, ctr4, key1, key2);
    end
    if R > 8
        key1, key2 = philox4x_bumpkey(key1, key2);
        ctr1, ctr2, ctr3, ctr4 = philox4x_round(ctr1, ctr2, ctr3, ctr4, key1, key2);
    end
    if R > 9
        key1, key2 = philox4x_bumpkey(key1, key2);
        ctr1, ctr2, ctr3, ctr4 = philox4x_round(ctr1, ctr2, ctr3, ctr4, key1, key2);
    end
    if R > 10
        key1, key2 = philox4x_bumpkey(key1, key2);
        ctr1, ctr2, ctr3, ctr4 = philox4x_round(ctr1, ctr2, ctr3, ctr4, key1, key2);
    end
    if R > 11
        key1, key2 = philox4x_bumpkey(key1, key2);
        ctr1, ctr2, ctr3, ctr4 = philox4x_round(ctr1, ctr2, ctr3, ctr4, key1, key2);
    end
    if R > 12
        key1, key2 = philox4x_bumpkey(key1, key2);
        ctr1, ctr2, ctr3, ctr4 = philox4x_round(ctr1, ctr2, ctr3, ctr4, key1, key2);
    end
    if R > 13
        key1, key2 = philox4x_bumpkey(key1, key2);
        ctr1, ctr2, ctr3, ctr4 = philox4x_round(ctr1, ctr2, ctr3, ctr4, key1, key2);
    end
    if R > 14
        key1, key2 = philox4x_bumpkey(key1, key2);
        ctr1, ctr2, ctr3, ctr4 = philox4x_round(ctr1, ctr2, ctr3, ctr4, key1, key2);
    end
    if R > 15
        key1, key2 = philox4x_bumpkey(key1, key2);
        ctr1, ctr2, ctr3, ctr4 = philox4x_round(ctr1, ctr2, ctr3, ctr4, key1, key2);
    end
    ctr1, ctr2, ctr3, ctr4
end

using Base: llvmcall
import Base.(+)

using ..Random123: R123Generator1x, R123Generator4x
import ..Random123: random123_r, set_counter!

const __m128i_lvec = NTuple{2, VecElement{UInt64}}
struct __m128i
    data::__m128i_lvec
end
Base.convert(::Type{__m128i}, x::UInt128) = unsafe_load(Ptr{__m128i}(pointer_from_objref(Ref(x))))
Base.convert(::Type{UInt128}, x::__m128i) = unsafe_load(Ptr{UInt128}(pointer_from_objref(Ref(x))))
Base.UInt128(x::__m128i) = convert(UInt128, x)
__m128i(x::UInt128) = convert(__m128i, x)
Base.convert(::Type{__m128i}, x::Union{Signed, Unsigned}) = convert(__m128i, UInt128(x))
Base.convert(::Type{T}, x::__m128i) where T <: Union{Signed, Unsigned} = convert(T, UInt128(x))

const LITTLE_ENDIAN = ENDIAN_BOM ≡ 0x04030201
__m128i(hi::UInt64, lo::UInt64) = @static LITTLE_ENDIAN ? __m128i((VecElement(lo), VecElement(hi))) : __m128i((VecElement(hi), VecElement(lo)))

Base.zero(::Type{__m128i}) = __m128i(zero(UInt64), zero(UInt64))
Base.one(::Type{__m128i}) = __m128i(zero(UInt64), one(UInt64))
Base.xor(a::__m128i, b::__m128i) = llvmcall(
    """%3 = xor <2 x i64> %1, %0
    ret <2 x i64> %3""",
    __m128i_lvec, Tuple{__m128i_lvec, __m128i_lvec},
    a.data, b.data
) |> __m128i
(+)(a::__m128i, b::__m128i) = llvmcall(
    """%3 = add <2 x i64> %1, %0
    ret <2 x i64> %3""",
    __m128i_lvec, Tuple{__m128i_lvec, __m128i_lvec},
    a.data, b.data
) |> __m128i
(+)(a::__m128i, b::Integer) = a + __m128i(UInt128(b))

_aes_enc(a::__m128i, round_key::__m128i) = ccall(
    "llvm.x86.aesni.aesenc",
    llvmcall,
    __m128i_lvec, (__m128i_lvec, __m128i_lvec),
    a.data, round_key.data
) |> __m128i
_aes_enc_last(a::__m128i, round_key::__m128i) = ccall(
    "llvm.x86.aesni.aesenclast",
    llvmcall,
    __m128i_lvec, (__m128i_lvec, __m128i_lvec),
    a.data, round_key.data
) |> __m128i
_aes_key_gen_assist(a::__m128i, ::Val{R}) where R = ccall(
    "llvm.x86.aesni.aeskeygenassist",
    llvmcall,
    __m128i_lvec, (__m128i_lvec, UInt8),
    a.data, R
) |> __m128i

"Abstract RNG that generates one number at a time and is based on AESNI."
abstract type AbstractAESNI1x <: R123Generator1x{UInt128} end
"Abstract RNG that generates four numbers at a time and is based on AESNI."
abstract type AbstractAESNI4x <: R123Generator4x{UInt32} end

@inline function set_counter!(
    r::AbstractAESNI4x,
    ctr::NTuple{4, Integer}
)
    r.p = 0
    r.ctr1 = union_uint(Tuple(x % UInt32 for x in ctr))
    random123_r(r)
    r
end

@inline inc_counter!(r::AbstractAESNI4x) = (r.ctr1 += one(__m128i); r)

__precompile__(true)

"""
The module for [Random123 Family](@ref).

Provide 8 RNG types:

- [`Threefry2x`](@ref)
- [`Threefry4x`](@ref)
- [`Philox2x`](@ref)
- [`Philox4x`](@ref)
- [`AESNI1x`](@ref)
- [`AESNI4x`](@ref)
- [`ARS1x`](@ref)
- [`ARS4x`](@ref)
"""
module Random123

using RandomNumbers

export set_counter!
include("common.jl")

export Threefry2x, Threefry4x, threefry
include("threefry.jl")

export Philox2x, Philox4x, philox
include("philox.jl")

export R123_USE_AESNI

"True when x86 AES-NI instructions have been detected."
const R123_USE_X86_AES_NI::Bool = @static if Sys.ARCH ≡ :x86_64 || Sys.ARCH ≡ :i686
        try
        cmd = Base.julia_cmd()
        push!(
            cmd.exec, "-e",
            "const __m128i = NTuple{2, VecElement{UInt64}};" *
            "@assert ccall(\"llvm.x86.aesni.aeskeygenassist\", " *
            "llvmcall, __m128i, (__m128i, UInt8), " *
            "__m128i((0x0123456789123450, 0x9876543210987654)), 0x1) ≡ " *
            "__m128i((0x857c266f7c266e85, 0x2346382146382023))"
        )
        success(cmd)
    catch e
        false
    end
else
    false
end

"True when Arm AArch64 FEAT_AES instructions have been detected."
const R123_USE_ARM_AARCH64_FEAT_AES::Bool = @static if Sys.ARCH ≡ :aarch64
        try
        cmd = Base.julia_cmd()
        push!(
            cmd.exec,
            "-e",
            "const uint8x16 = NTuple{16, VecElement{UInt8}};" *
            "@assert ccall(\"llvm.aarch64.crypto.aesmc\", " *
            "llvmcall, uint8x16, (uint8x16,), " *
            "uint8x16((0x4a, 0x68, 0xbd, 0xe1, 0xfe, 0x16, 0x3d, " *
            "0xec, 0xde, 0x06, 0x72, 0x86, 0xe3, 0x8c, 0x14, 0xd9))) ≡ " *
            "uint8x16((0x70, 0xa7, 0x7b, 0xd2, 0x0c, 0x79, 0xbd, " *
            "0xf1, 0x59, 0xc2, 0xad, 0x1a, 0x9f, 0x05, 0x37, 0x0f))",
        )
        success(cmd)
    catch e
        false
    end
else
    false
end

"True when Arm AArch32 FEAT_AES instructions have been detected."
const R123_USE_ARM_AARCH32_FEAT_AES::Bool = @static if startswith(String(Sys.ARCH), "arm")
        try
        cmd = Base.julia_cmd()
        push!(
            cmd.exec,
            "-e",
            "const uint8x16 = NTuple{16, VecElement{UInt8}};" *
            "@assert ccall(\"llvm.arm.crypto.aesmc\", " *
            "llvmcall, uint8x16, (uint8x16,), " *
            "uint8x16((0x4a, 0x68, 0xbd, 0xe1, 0xfe, 0x16, 0x3d, " *
            "0xec, 0xde, 0x06, 0x72, 0x86, 0xe3, 0x8c, 0x14, 0xd9))) ≡ " *
            "uint8x16((0x70, 0xa7, 0x7b, 0xd2, 0x0c, 0x79, 0xbd, " *
            "0xf1, 0x59, 0xc2, 0xad, 0x1a, 0x9f, 0x05, 0x37, 0x0f))",
        )
        success(cmd)
    catch e
        false
    end
else
    false
end

const R123_USE_ARM_FEAT_AES::Bool = R123_USE_ARM_AARCH64_FEAT_AES || R123_USE_ARM_AARCH32_FEAT_AES

"True when AES-acceleration instructions have been detected."
const R123_USE_AESNI::Bool = R123_USE_X86_AES_NI || R123_USE_ARM_FEAT_AES

@static if R123_USE_AESNI
    export AESNI1x, AESNI4x, aesni
    export ARS1x, ARS4x, ars
else
    @warn "AES-acceleration instructions have not been detected, so the related RNGs (AESNI and ARS) are not available."
end

@static if R123_USE_X86_AES_NI
    include("./x86/aesni_common.jl")
    include("./x86/aesni.jl")
    include("./x86/ars.jl")
elseif R123_USE_ARM_FEAT_AES
    include("./arm/aesni_common.jl")
    include("./arm/aesni.jl")
    include("./arm/ars.jl")
end

end

using RandomNumbers
using Random123
import Random: seed!
using Test: @test, @test_throws, @testset, @inferred
using Printf: @printf

@info "Testing Random123"

@testset "functional API" begin
    get_key = Random123.get_key
    get_ctr = Random123.get_ctr
    seed1 = 1
    seed2 = (1,2)
    seed4 = (1,2,3,4)
    AlgChoice = Tuple{Random123.AbstractR123, Function, Union{Tuple{}, Tuple{Val}}}
    alg_choices = AlgChoice[
        (Threefry2x(UInt32, seed2) , threefry, (Val(20),)) ,
        (Threefry2x(UInt64, seed2) , threefry, (Val(20),)) ,
        (Threefry4x(UInt32, seed4) , threefry, (Val(20),)) ,
        (Threefry4x(UInt64, seed4) , threefry, (Val(20),)) ,
        (Philox2x(UInt32  , seed1) , philox  , (Val(10),)) ,
        (Philox2x(UInt64  , seed1) , philox  , (Val(10),)) ,
        (Philox4x(UInt32  , seed2) , philox  , (Val(10),)) ,
        (Philox4x(UInt64  , seed2) , philox  , (Val(10),)) ,
    ]
    @static if R123_USE_AESNI
        append!(alg_choices, AlgChoice[
            (AESNI1x(seed1) , aesni , ()        ) ,
            (AESNI4x(seed4) , aesni , ()        ) ,
            (ARS1x(seed1)   , ars   , (Val(7),) ) ,
            (ARS4x(seed4)   , ars   , (Val(7),) ) ,
        ])
    end
    for (rng, alg, options) in alg_choices
        key = @inferred get_key(rng)
        ctr = @inferred get_ctr(rng)
        @test isbitstype(typeof(key))
        @test isbitstype(typeof(ctr))
        @test key isa Tuple
        @test ctr isa Tuple
        @test eltype(key) <: Union{UInt32, UInt64, UInt128}
        @test eltype(ctr) <: Union{UInt32, UInt64, UInt128}
        val1 = @inferred alg(key, ctr, options...)
        val2 = @inferred alg(key, ctr, options...)
        @test val1 === val2
        @test val1 isa Tuple
        @test isbitstype(typeof(val1))
        @test eltype(val1) <: Union{UInt32, UInt64, UInt128}
    end
end
@testset "functional consistency" begin
    get_key = Random123.get_key
    get_ctr = Random123.get_ctr
    for T in [UInt32, UInt64]
        for (rng, alg, option) in [
                (Threefry2x(T, (T(123), T(456))), threefry, Val(20)),
                (Philox2x(T, 456), philox, Val(10)),
           ]

            key = @inferred get_key(rng)
            x1 = rand(rng, T)
            y1,y0 = alg(key, get_ctr(rng), option)
            @test x1 === y1
            x2 = rand(rng, T)
            x3 = rand(rng, T)
            ctr = get_ctr(rng)
            y3,y2 = alg(key, get_ctr(rng), option)
            @test x2 === y2
            @test x3 === y3
        end
    end
    for T in [UInt32, UInt64]
        key = (T(123), T(456), T(7), T(8))
        rng = Threefry4x(T, key)
        x1 = rand(rng, T)
        x2 = rand(rng, T)
        x3 = rand(rng, T)
        x4 = rand(rng, T)
        x5 = rand(rng, T)
        x6 = rand(rng, T)
        x7 = rand(rng, T)
        x8 = rand(rng, T)
        x9 = rand(rng, T)
        y1,y2,y3,y4 = threefry(key, (T(0), T(0), T(0), T(0)), Val(20))
        y5,y6,y7,y8 = threefry(key, (T(1), T(0), T(0), T(0)), Val(20))
        y9,_,_,_    = threefry(key, (T(2), T(0), T(0), T(0)), Val(20))
        @test x1 === y1
        @test x2 === y2
        @test x3 === y3
        @test x4 === y4
        @test x5 === y5
        @test x6 === y6
        @test x7 === y7
        @test x8 === y8
        @test x9 === y9
    end

    if R123_USE_AESNI
        rng = ARS1x(1)
        @test (rand(rng, UInt128),) === ars(get_key(rng), get_ctr(rng), Val(7))
        @test (rand(rng, UInt128),) === ars(get_key(rng), get_ctr(rng), Val(7))
        @test (rand(rng, UInt128),) === ars(get_key(rng), get_ctr(rng), Val(7))
        @test (rand(rng, UInt128),) === ars(get_key(rng), get_ctr(rng), Val(7))

        rng = AESNI1x(1)
        @test (rand(rng, UInt128),) === aesni(get_key(rng), get_ctr(rng))
        @test (rand(rng, UInt128),) === aesni(get_key(rng), get_ctr(rng))
        @test (rand(rng, UInt128),) === aesni(get_key(rng), get_ctr(rng))
        @test (rand(rng, UInt128),) === aesni(get_key(rng), get_ctr(rng))
    end

end


function compare_dirs(dir1::AbstractString, dir2::AbstractString)
    files1 = readdir(dir1)
    files2 = readdir(dir2)
    @test files1 == files2

    for file in files1
        file1 = joinpath(dir1, file)
        file2 = joinpath(dir2, file)
        lines1 = readlines(file1)
        lines2 = readlines(file2)
        @test lines1 == lines2
    end
end

strip_cr(line::String) = replace(line, r"\r\n$" => "\n")

stdout_ = stdout
pwd_ = pwd()
cd(dirname(@__FILE__))
rm("./actual"; force=true, recursive=true)
mkpath("./actual")

for (rng_name, seed_t, stype, seed, args) in (
    (:Threefry2x, NTuple{2, UInt32}, UInt32, (123, 321), (32,)),
    (:Threefry2x, NTuple{2, UInt64}, UInt64, (123, 321), (32,)),
    (:Threefry4x, NTuple{4, UInt32}, UInt32, (123, 321, 456, 654), (72,)),
    (:Threefry4x, NTuple{4, UInt64}, UInt64, (123, 321, 456, 654), (72,)),
    (:Philox2x,   UInt32, UInt32, 123, (16,)),
    (:Philox2x,   UInt64, UInt64, 123, (16,)),
    (:Philox4x,   NTuple{2, UInt32}, UInt32, (123, 321), (16,)),
    (:Philox4x,   NTuple{2, UInt64}, UInt64, (123, 321), (16,))
)
    outfile = open(string(
        "./actual/check-$(string(lowercase("$rng_name"), sizeof(stype)<<3)).out"
    ), "w")
    redirect_stdout(outfile)

    @eval $rng_name($stype)
    x = @eval $rng_name($stype, $seed, $(args...))
    @test seed_type(x) == seed_t
    @test copyto!(copy(x), x) == x

    x.p = 1
    rand(x, UInt64)
    x.p = 1
    rand(x, UInt128)
    @eval rand($x, NTuple{$(string(rng_name)[end-1]-'0'), $stype})

    set_counter!(x, 0)
    for i in 1:100
        @printf "%.9f\n" rand(x)
    end

    close(outfile)
end
redirect_stdout(stdout_)

compare_dirs("expected", "actual")
cd(pwd_)

@static if Random123.R123_USE_X86_AES_NI
    include("./x86/aesni.jl")
    include("./x86/ars.jl")
elseif Random123.R123_USE_ARM_FEAT_AES
    include("./arm/aesni.jl")
    include("./arm/ars.jl")
end

import Random: seed!
using Test: @test, @testset

using RandomNumbers
using Random123

import RandomNumbers: split_uint
import Random123: __m128i

@testset "Accelerated ARS" begin
    x = zero(__m128i)
    ctr = __m128i(0x9799b5d54f7b9227, 0xb47607190d0dfefb)
    key = __m128i(0x07b8e4b6aa98ec24, 0x5a7da274d3b8146a)
    @test rand(ARS1x{1}(x, ctr, key), UInt128) ≡ 0x1a0b14c707b64224e548ef12331396ef
    @test rand(ARS1x{2}(x, ctr, key), UInt128) ≡ 0x3ced8e0970690f718336318ba22e8ae1
    @test rand(ARS1x{3}(x, ctr, key), UInt128) ≡ UInt128(__m128i(0xb6621a8b006319e8, 0x67c841642c32fc19))
    @test rand(ARS1x{10}(x, ctr, key), UInt128) ≡ UInt128(__m128i(0xac35df44f996ed82, 0x4e287697bad2f9a2))

    key = rand(UInt128)
    r = ARS1x(key)
    r1 = ARS4x(split_uint(key, UInt32))
    @test seed_type(r) ≡ UInt128
    @test seed_type(r1) ≡ NTuple{4, UInt32}
    @test copyto!(copy(r), r) == r
    @test copyto!(copy(r1), r1) == r1
    @test UInt128(r.x) ≡ rand(r1, UInt128)
    @test rand(r, UInt128) ≡ rand(r1, UInt128)
    set_counter!(r, 0)
    set_counter!(r1, 1)
    @test rand(r, Tuple{UInt128})[1] ≡ rand(r1, UInt128)
end
